// -- DlxvClas.h:
// Fichero donde se realiza la declaracin de las clases utilizadas en el
// entorno de usuario del Simulador.

/****************************************************************
 * PROYECTO FINAL DE CARRERA:		        		*
 *	Simulador Vectorial para PC bajo entorno Windows	*
 * 		                                		*
 *      Autor: Roberto Calpe Lorenzo				*
 *                                                              *
 ****************************************************************/

_CLASSDEF(TMDIFileApp)
_CLASSDEF(TMDIFileWindow)
_CLASSDEF(TNFileW)


class _CLASSTYPE TMDIFileApp : public TApplication {
public:
    TMDIFileApp(LPSTR name, HINSTANCE hInstance,
		  HINSTANCE hPrevInstance, LPSTR lpCmd,
		  int nCmdShow)
		: TApplication(name, hInstance,
			       hPrevInstance, lpCmd, nCmdShow) {};
    virtual void InitMainWindow();
    virtual void InitInstance();

protected:

    virtual BOOL ProcessAppMsg(LPMSG PMessage);

};

class _CLASSTYPE TMDIFileWindow : public TMDIFrame {

    PTPrinter Printer;

public:

    WORD ChildNum;

    TMDIFileWindow(LPSTR ATitle, LPSTR MenuName);
    ~TMDIFileWindow( void );

    /* Aqui asociamos cada constante definida en dlxvsin.h con
    una accion del codigo de dlxvsim.cpp */
    virtual void SetupWindow();
    virtual void ShutDownWindow();
    virtual void rellenar(LPSTR Titulo, LPSTR Temp);
    virtual void Actualizar();
    virtual void Presentes();
    virtual void Errores();
    virtual void Limpia();
    virtual void AyudaIndice(RTMessage Msg) =
		 [CM_FIRST + IDM_HELP_INDEX];
    virtual void AyudaTeclado(RTMessage Msg) =
		 [CM_FIRST + IDM_HELP_KEYBOARD];
    virtual void AyudaAyuda(RTMessage Msg) =
		 [CM_FIRST + IDM_HELP_HELP];
    virtual void NewFile(RTMessage Msg) =
		 [CM_FIRST + CM_MDIFILENEW];
    virtual void OpeFile(RTMessage Msg) =
		 [CM_FIRST + CM_MDIFILEOPEN];
    virtual void SaveState(RTMessage Msg) =
		 [CM_FIRST + CM_SAVESTATE];
    virtual void RestoreState(RTMessage Msg) =
		 [CM_FIRST + CM_RESTORESTATE];
    virtual void Variables(RTMessage Msg) =
		 [CM_FIRST + CM_VARIAB];
    virtual void Crear_Sim(RTMessage Msg) =
		 [CM_FIRST + CM_CREASIM];
    virtual void Modi_Sim(RTMessage Msg) =
		 [CM_FIRST + CM_MODIFI];
    virtual void Ensamblar(RTMessage Msg) =
		 [CM_FIRST +CM_ENSAMBLA];
    virtual void Cargar(RTMessage Msg) =
		 [CM_FIRST + CM_CARGA];
    virtual void CargarT(RTMessage Msg) =
		 [CM_FIRST + CM_CARGAT];
    virtual void Estad(RTMessage Msg) =
		 [CM_FIRST + CM_ESTADIST];
    virtual void Expf(RTMessage Msg) =
		 [CM_FIRST + CM_EXPF];
    virtual void Expot(RTMessage Msg) =
		 [CM_FIRST + CM_EXOT];
    virtual void Modpf(RTMessage Msg) =
		 [CM_FIRST + CM_MODPF];
    virtual void Modot(RTMessage Msg) =
		 [CM_FIRST + CM_MODOT];
    virtual void GoDes(RTMessage Msg) =
		 [CM_FIRST + CM_GO];
    virtual void GoCont(RTMessage Msg) =
		 [CM_FIRST + CM_GOCONT];
    virtual void Step(RTMessage Msg) =
		 [CM_FIRST + CM_STEP];
    virtual void Paso(RTMessage Msg) =
		 [CM_FIRST + CM_PASO];
    virtual void Stopat(RTMessage Msg) =
		 [CM_FIRST + CM_STOPAT];
    virtual void Stopin(RTMessage Msg) =
		 [CM_FIRST +CM_STOPIN];
    virtual void Stopde(RTMessage Msg) =
		 [CM_FIRST + CM_STOPDE];
    virtual void Parar(RTMessage Msg) =
		 [CM_FIRST + CM_PARAR];
    virtual void Destruir(RTMessage Msg) =
		 [CM_FIRST + CM_DESTROY];
    virtual void Trace(RTMessage Msg) =
		 [CM_FIRST + CM_TRACE];
    virtual void Sobre(RTMessage Msg) =
		 [CM_FIRST + CM_SOBRE];
    virtual void Actu(RTMessage Msg) =
		 [CM_FIRST + CM_ACT];
    virtual void Enca(RTMessage Msg) =
		 [CM_FIRST + CM_ENCA];
    virtual void ExaVect( RTMessage  Msg) =
		 [CM_FIRST + CM_EXAVEC];
    virtual void ModVect( RTMessage  Msg) =
		 [CM_FIRST + CM_MODVEC];
    virtual void Borrar( RTMessage  Msg) =
		 [CM_FIRST + CM_BORRAR];
    virtual void Indice( RTMessage  Msg) =
		 [CM_FIRST + CM_INDICE];
    virtual void Sistema( RTMessage  Msg) =
		 [CM_FIRST + CM_SISTEMA];
    virtual void Fuentes(RTMessage Msg) =
		 [CM_FIRST + CM_FUENTES];
    virtual void CMFilePrinterSetup(RTMessage Msg) =
		 [CM_FIRST + CM_FILEPRINTERSETUP];
    virtual void CMFilePrint(RTMessage Msg) =
		 [CM_FIRST + CM_FILEPRINT];
    virtual void CMSalCar(RTMessage Msg) =
		 [CM_FIRST + CM_SALCAR];
    virtual void CMSalir(RTMessage Msg) =
		 [CM_FIRST + CM_SALIR];
    virtual void WMDropFiles( RTMessage ) = [WM_FIRST + WM_DROPFILES ];
    virtual void WMStatus(RTMessage Msg) = [WM_FIRST + WM_STATUS];
    virtual void WMFuentes(RTMessage Msg) = [WM_FIRST + WM_FUENTES];
    virtual void WMFicheros(RTMessage Msg) = [WM_FIRST + WM_FICHEROS];
/* Marzo 98 */
    virtual void CMSalvarComo(RTMessage Msg) =
		 [CM_FIRST + CM_SALCOMO];
    virtual void ExpFPRegs(RTMessage Msg) =
		 [CM_FIRST + CM_EXFP];
    virtual void ExpDFPRegs(RTMessage Msg) =
		 [CM_FIRST + CM_EXDFP];
    virtual void ExpRegs(RTMessage Msg) =
		 [CM_FIRST + CM_EXREG];
    virtual void ExpSpecial(RTMessage Msg) =
		 [CM_FIRST + CM_EXSP];
    virtual void ExpPCFast(RTMessage Msg) =
		 [CM_FIRST + CM_EXPCFAST];
    virtual void SetBorrarAuto(RTMessage Msg) =
		 [CM_FIRST + CM_BORRARAUTO];
    virtual void SetBorraRegsAuto(RTMessage Msg) =
		 [CM_FIRST + CM_BORRAREGSAUTO];

protected:

    virtual void GetWindowClass(WNDCLASS _FAR & AWndClass);


    virtual void WMLButtonDown(RTMessage Msg) =
		 [WM_FIRST + WM_LBUTTONDOWN];
    virtual void WMLButtonUp(RTMessage Msg) =
		 [WM_FIRST + WM_LBUTTONUP];
    virtual void WMMouseMove(RTMessage Msg) =
		 [WM_FIRST + WM_MOUSEMOVE];
    virtual void WMNCMouseMove(RTMessage Msg) =
		 [WM_FIRST + WM_NCMOUSEMOVE];
    virtual void WMCommand(RTMessage Msg) =
		 [WM_FIRST + WM_COMMAND];
    virtual void WMSysCommand(RTMessage Msg) =
		 [WM_FIRST + WM_SYSCOMMAND];
    virtual void WMIdle(RTMessage Msg) =
		 [WM_FIRST + WM_ENTERIDLE];
    virtual void WMCursor(RTMessage Msg) =
		 [WM_FIRST + WM_SETCURSOR];
    virtual void WMPaint(RTMessage Msg) =
		 [WM_FIRST + WM_PAINT];
    virtual void WMSize(RTMessage Msg) =
		 [WM_FIRST + WM_SIZE];
    virtual void WMMenuSel(RTMessage Msg) =
		 [WM_FIRST + WM_MENUSELECT];


};

class _CLASSTYPE TNFileW : public TFileWindow
{
public:

	char szname[MAXPATH];


	TNFileW( PTWindowsObject AParent, LPSTR ATitle, LPSTR AFileName, HFONT Fuente, int nfuent)
	:TFileWindow(AParent, ATitle, AFileName, Fuente, nfuent)
	{
	lstrcpy(szname, AFileName);
	};

	void Ira(int especial);


protected:
	virtual void IrLinea(RTMessage Msg) = [CM_FIRST + CM_LINEA];
};

_CLASSDEF(TFileOut)
class TFileOut : public TPrintout
{

  public:

    PTNFileW Archiv;
    BOOL Inicio, NuevaPag;
    int Primera;

    TFileOut(Pchar ATitle, PTNFileW Archivo) : TPrintout(ATitle)
    {
     Archiv = Archivo;
     Inicio = TRUE;
     NuevaPag = FALSE;
    }
    virtual void PrintPage(HDC DC, WORD Page, POINT Size, LPRECT Rect,
	WORD Flags);
    void SetBanding( BOOL b ) { Banding = b; }
    virtual BOOL IsNextPage();

};


class TLineaDlg : public TDialog {
public:
    int lineas;

    TLineaDlg(PTWindowsObject AParent, LPSTR name, int numl);
    virtual BOOL CanClose();
};


class TVentanaInfoSis : public TDialog
{
public:
	TVentanaInfoSis( PTWindowsObject AParent, LPSTR name );
};

class TVariabDlg : public TDialog {
public:
    TVariabDlg(PTWindowsObject AParent, LPSTR name);
    virtual BOOL CanClose();
private:
    BOOL ValidNum(long int num);
    BOOL ValidLat(long int num);
    BOOL ValidMem(long int num);
    BOOL Poten2(long int numero);
};

class TEnsDlg : public TDialog {
public:
    TCheckBox *CheckBox;

    TEnsDlg(PTWindowsObject AParent, LPSTR name);
    virtual BOOL CanClose();
};

class TStopatDlg : public TDialog {
public:
    TCheckBox *CheckBox;

    TStopatDlg(PTWindowsObject AParent, LPSTR name);
    virtual BOOL CanClose();
};

class TRunDlg : public TDialog {
public:
    TCheckBox *CheckBox;

    TRunDlg(PTWindowsObject AParent, LPSTR name);
    virtual void SetupWindow();
    virtual BOOL CanClose();
};

class TEstDlg : public TDialog {
public:
    TCheckBox *CheckBox1, *CheckBox2, *CheckBox3,
    *CheckBox4, *CheckBox5, *CheckBox6, *CheckBox7;

    TEstDlg(PTWindowsObject AParent, LPSTR name);
    virtual void SetupWindow();
    virtual BOOL CanClose();
};

class TModotDlg : public TDialog {
public:
    TModotDlg(PTWindowsObject AParent, LPSTR name);
    virtual BOOL CanClose();
};

class TExotDlg : public TDialog {
public:
    TCheckBox *CheckBox1, *CheckBox2, *CheckBox3,
    *CheckBox4, *CheckBox5, *CheckBox6, *CheckBox7,
    *CheckBox8, *CheckBox9, *CheckBox10;


    TExotDlg(PTWindowsObject AParent, LPSTR name);
    virtual void SetupWindow();
    virtual void Continuar(RTMessage Msg) = [ID_FIRST + IDRETRYM];
    virtual BOOL CanClose();
};

class TPFDlg : public TDialog {
public:
    TRadioButton *RTBut1, *RTBut2;

    TPFDlg(PTWindowsObject AParent, LPSTR name);
    virtual void SetupWindow();
    virtual void Continuar(RTMessage Msg) = [ID_FIRST + IDRETRYM];
    virtual BOOL CanClose();
};

class TPutFDlg : public TDialog {
public:
    TRadioButton *RTBut1, *RTBut2;

    TPutFDlg(PTWindowsObject AParent, LPSTR name);
    virtual void SetupWindow();
    virtual BOOL CanClose();
};

class TFuentesDlg : public TDialog {
public:
    TRadioButton *RTBut[4];
    TCheckBox *CheckBox1;

    TFuentesDlg(PTWindowsObject AParent, LPSTR name);
    virtual void SetupWindow();
    virtual BOOL CanClose();
};

class TDelDlg : public TDialog {
public:

    TDelDlg(PTWindowsObject AParent, LPSTR name);
    virtual BOOL CanClose();
};

class TTraDlg : public TDialog {
public:
    TRadioButton *RTBut1, *RTBut2;

    TTraDlg(PTWindowsObject AParent, LPSTR name);
    virtual void SetupWindow();
    virtual BOOL CanClose();
};

class TExavDlg : public TDialog {
public:

    TExavDlg(PTWindowsObject AParent, LPSTR name);
    virtual void Continuar(RTMessage Msg) = [ID_FIRST + IDRETRYM];
    virtual BOOL CanClose();
};

class TElegDlg : public TDialog {
public:
    TRadioButton *RTBut, *RTBut1, *RTBut2, *RTBut3, *RTBut4,
    *RTBut5, *RTBut6, *RTBut7;

    TElegDlg(PTWindowsObject AParent, LPSTR name);
    virtual BOOL CanClose();
};

class TModVDlg : public TDialog {
public:

    TModVDlg(PTWindowsObject AParent, LPSTR name);
    virtual BOOL CanClose();
};

class TIndexDlg : public TDialog {
public:

    TIndexDlg(PTWindowsObject AParent, LPSTR name);
    virtual void Continuar(RTMessage Msg) = [ID_FIRST + IDRETRYM];
    virtual BOOL CanClose();
};

