/*
 * DlxvSim.cpp --     
 *
 *	Fichero principal del simulador vectorial.
 *	Este fichero implementa el entorno Windows usado por
 *	el simulador.
 *
 * Copyright 1992 Roberto Calpe Lorenzo.
 */

/* PROYECTO FINAL DE CARRERA:                                   *
 *                                                              *
 *      Simulador Vectorial para PC bajo entorno Windows v3.1   *
 *                                                              *
 *      Autor: Roberto Calpe Lorenzo                            *
 *                                                              *
 *      Director: Pedro Lpez Rodrguez                         *
 *                                                              *
 *      Departamento: ISCA. Grupo de Arquitecturas Paralelas    *
 *                                                              *
 *                                                              *
 *      Universidad Politcnica de Valencia. Diciembre 1992     *
 *                                                              *
 *                                                              *
 *      Errores: Todos los errores que sean detectados por los  *
 *      usuarios del simulador, pueden ser enviados a la        *
 *      siguiente direccin de correo electrnico para su       *
 *      correccin:                                             *                
 *                                                              *
 *      E-MAIL = plopez@disca.upv.es                            *
 *                                                              *
 */

#include <windowsx.h>
#include <owl.h>
#include <bwcc.h>
#include <shellapi.h>
#include <dialog.h>
#include <stdio.h>
#include <string.h>
#include <commdlg.h>
#include <radiobut.h>
#include <filewnd.h>
#include <values.h>
#include <signal.h>
#include <ctype.h>
#include <alloc.h>
#include "listwin.h"
#include "printer.h"
#include "ids.h"
#include "dlx.h"
#include "dlxvsin.h"
#include "dlxvclas.h"


const char far DskFile[] = "DLXVSIM.EST";

char far salidas[199];
char far temporal[199];

BOOL actual = TRUE;

BOOL encadenado = FALSE;

BOOL borrarauto = TRUE; /* Borra los simbolos al cargar */

BOOL borraRegsauto = TRUE; /* Borra los registros al ejecutar */

BOOL bProgramaCargado = FALSE; /* Se ha cargado un programa por primera vez? */

HWND easy=NULL;

BOOL iniciar = TRUE;

BOOL       bAyuda = FALSE;

char       NombreAyuda[EXE_NAME_MAX_SIZE+1];

HCURSOR    hCursorAyuda;

HINSTANCE     hInst;

HBITMAP bmpStatusLine;
HBITMAP bmpStatusBar;
HBITMAP bmpHerramienta;
HBITMAP bmpNohabil;


//Los botones que aparecen en la parte superior
/* la accion asociada es la correspondiente a la constante que
se le asigne (ver dlxvclas.h) */
/* El icono que se le asigna lo saca de los bitmaps definidos
en dlxvsim.res. Cada boton necesita dos bitmaps, sin pulsar y pulsado
Los bitmaps 1 y 2 corresponde al primer boton, etc ... */

#define MBOT	21

int acciones[MBOT] ={ IDM_HELP_INDEX, IDM_OPEN, CM_FUENTES, CM_VARIAB, CM_SALIR, CM_BORRAR,
		      CM_CARGA, CM_CARGAT, CM_SALCAR, CM_ESTADIST, CM_EXREG, CM_EXFP, CM_EXDFP,
		      CM_EXPF, CM_EXAVEC, CM_EXPCFAST /* CM_INDICE */, CM_EXSP /* CM_EXOT */,
		      CM_MODPF, CM_MODVEC, CM_MODOT, CM_PARAR};

struct Boto {
	HBITMAP bmpa, bmpb;
	BOOL habil;
	int accion, x;
	}Botones[MBOT];

int maxbot, BPintado;
BOOL Pintado = FALSE;

FILE *nombref;

char titulo[100];


int cuenta, registro, longitud, CurrentID;
char prueba[largus];
char ChildName[14];
HMENU menu, CurrentPopup;
OPENFILENAME ofnTemp;
char szName[MAXPATH];
int linea;
char argum[8];
TListWin *Ventana;
BOOL bSalvarComo = FALSE;

static DLXV *machPtr;
extern "C"{ DLXV *    Sim_Create(long, long, long, long, long, long, long,
				long, long, long, long, long, long, long,
				long, long, long, long, int, int);
	    long int Asm_LoadCmd(DLXV *, int, char[argus][largus]);
	    long int Stop_StopCmd(DLXV *, int, char[argus][largus]);
	    void     Sim_Stop(DLXV *);
	    long int Asm_AsmCmd(DLXV *, int, char[argus][largus]);
	    long int Sim_GoCmd(DLXV *, int, char[argus][largus]);
	    long int Sim_StepCmd(DLXV *, int, char[argus][largus]);
	    long int Sim_DumpStats(DLXV *, int, char[argus][largus]);
	    long int Gp_PutCmd(DLXV *, int, char[argus][largus]);
	    long int Gp_GetCmd(DLXV *, int, char[argus][largus]);
	    long int Gp_FGetCmd(DLXV *, int, char[argus][largus]);
	    long int Gp_FPutCmd(DLXV *, int, char[argus][largus]);
	    long int Gp_Vget(DLXV *, char[argus][largus]);
	    long int Gp_PCindex(DLXV *, char[argus][largus]);
	    long int Sim_TraceCmd(DLXV *, int, char[argus][largus]);
	    void     Sym_DeleteSymbols(DLXV *, char[MAXPATH]);
	    void     Sym_Tabla(DLXV *, long);
	    void     statsReset(DLXV *);
            void     regsReset(DLXV *);
	   }


void HacerNombreCamino(char *);

typedef void (*fptr)(int);
void Interrupt()
{
  BWCCMessageBox(GetFocus(),"Security Alert", "Interrupts", MB_OK | MB_ICONINFORMATION);
  Sim_Stop(machPtr);
  signal(SIGINT, (fptr)Interrupt);
}

void DoSize(HWND hWindow)
{
	RECT rect;
        HDC DC, srcDC, destDC;
        HBITMAP bmp, bmph;
	HANDLE oldSrc, oldDest;

	GetClientRect(hWindow, &rect);

	MoveWindow(GetWindow(hWindow, GW_CHILD), 0, TAMBOTV, rect.right, rect.bottom-(TAMBOTV+22), 0);
	InvalidateRect(hWindow, NULL, 0);
	DC = GetDC(hWindow);
	srcDC = CreateCompatibleDC(DC);
	destDC = CreateCompatibleDC(DC);
	ReleaseDC(hWindow, DC);

	bmp = LoadBitmap(hInst, MAKEINTRESOURCE(bmp_StatusLine));
        oldSrc = SelectObject(srcDC, bmp);
        if (bmpStatusLine)
          DeleteObject(bmpStatusLine);
	bmpStatusLine = CreateCompatibleBitmap(DC, rect.right, 22);
        oldDest = SelectObject(destDC, bmpStatusLine);
	BitBlt(destDC, 0, 0, 5, 22, srcDC, 0, 0, SRCCOPY);
        StretchBlt(destDC, 5, 0, rect.right - 5, 22,
                           srcDC, 6, 0, 22, 22, SRCCOPY);
	BitBlt(destDC, rect.right - 5, 0, 5, 22, srcDC, 59, 0, SRCCOPY);
	DeleteObject(bmp);


	bmph = LoadBitmap(hInst, MAKEINTRESOURCE(bmp_Herramienta));
	oldSrc = SelectObject(srcDC, bmph);
        if (bmpHerramienta)
          DeleteObject(bmpHerramienta);
	bmpHerramienta = CreateCompatibleBitmap(DC, rect.right, TAMBOTV);
        oldDest = SelectObject(destDC, bmpHerramienta);
	BitBlt(destDC, 0, 0, 5, TAMBOTV, srcDC, 0, 0, SRCCOPY);
	StretchBlt(destDC, 5, 0, rect.right - 5, TAMBOTV,
			   srcDC, 6, 0, TAMBOTV, TAMBOTV, SRCCOPY);
	BitBlt(destDC, rect.right - 5, 0, 5, TAMBOTV, srcDC, 59, 0, SRCCOPY);

	SelectObject(srcDC, oldSrc);
        SelectObject(destDC, oldDest);
        DeleteDC(srcDC);
        DeleteDC(destDC);
	DeleteObject(bmph);



}

void BlastStatusLine(HWND hWindow, HDC PaintDC)
{
        HDC memDC;
        RECT clientRect;
	HANDLE oldBmp;

        GetClientRect(hWindow, &clientRect);
        memDC = CreateCompatibleDC(PaintDC);
        oldBmp = SelectObject(memDC, bmpStatusLine);
	BitBlt(PaintDC, 0, clientRect.bottom - 22,
                clientRect.right - clientRect.left, 22,
		memDC, 0, 0, SRCCOPY);

	SelectObject(memDC, oldBmp);
        

        DeleteDC(memDC);
}


void BlastBotones(HWND hWindow, HDC PaintDC)
{
        HDC memDC;
        RECT clientRect;
	HANDLE oldBmp;
	int i;

        GetClientRect(hWindow, &clientRect);
	memDC = CreateCompatibleDC(PaintDC);

	oldBmp = SelectObject(memDC, bmpHerramienta);
	BitBlt(PaintDC, 0, 0,
		clientRect.right - clientRect.left, TAMBOTV,
		memDC, 0, 0, SRCCOPY);

	for (i=0;i<maxbot;i++)
	{
	  if (Botones[i].habil)
          {
	  SelectObject(memDC, Botones[i].bmpa);
	  BitBlt(PaintDC, i*TAMBOTH, 0, TAMBOTH, TAMBOTV, memDC, 0, 0, SRCCOPY);
	  }
	  else
	  {
	  SelectObject(memDC, bmpNohabil);
	  BitBlt(PaintDC, i*TAMBOTH, 0, TAMBOTH, TAMBOTV, memDC, 0, 0, SRCCOPY);
	  }
	}

	SelectObject(memDC, oldBmp);
        DeleteDC(memDC);
}

void DoPaint(HWND hWindow)
{
        HDC PaintDC;
        PAINTSTRUCT PS;

	PaintDC = BeginPaint(hWindow, &PS);
	BlastStatusLine(hWindow, PaintDC);
	BlastBotones(hWindow, PaintDC);
	EndPaint(hWindow, &PS);
}

void menuSelect(HWND hWindow, WORD wParam, LONG lParam)
{

  if (LOWORD(lParam) == 0x0FFFF)
  {
	CurrentPopup = 0;
	CurrentID = 1;
  }
  else
  if (LOWORD(lParam) & MF_POPUP)
  {
        CurrentPopup = (HMENU) wParam;
        CurrentID = 0;
  }
  else
        CurrentID = wParam;
  PostMessage(hWindow,WM_STATUS, 0, 0);
}

void drawStatusLine(HWND hWindow)
{
  HDC DC, memDC;
  HANDLE oldBmp;
  RECT Rect;
  char Str[128];
  int StrID;

  if (CurrentID)
  {
        switch(CurrentID)
	{
	/* Aqui asociamos una tira de caracteres a cada una de
	acciones del menu. La definicion de la tira esta en
        dlxvsin.h, que a su vez se toma de dlxvsim.res */
	  case Nombre: StrID = sth_Nombre; break;
          case IDM_NEW: StrID = sth_FileNew; break;
          case IDM_OPEN: StrID = sth_FileOpen; break;
          case IDM_SAVE: StrID = sth_FileSave; break;
	  case IDM_SAVEAS: StrID = sth_FileSaveAs; break;
	  case IDM_EXIT: StrID = sth_FileExit; break;
	  case CM_VARIAB: StrID = sth_Config; break;
	  case CM_CREASIM: StrID = sth_Crear; break;
	  case CM_MODIFI: StrID = sth_Modif; break;
	  case CM_BORRAR: StrID = sth_Borr; break;
	  case CM_DESTROY: StrID = sth_Borrf; break;
	  case CM_CARGA: StrID = sth_Cargao; break;
	  case CM_CARGAT: StrID = sth_Cargat; break;
	  case CM_ENSAMBLA: StrID = sth_Ensamb; break;
	  case CM_ESTADIST: StrID = sth_Estadist; break;
	  case CM_TRACE: StrID = sth_Trace; break;
	  case CM_EXPF: StrID = sth_Expf; break;
	  case CM_EXAVEC: StrID = sth_Exv; break;
	  case CM_INDICE: StrID = sth_Ind; break;
	  case CM_EXOT: StrID = sth_Exo; break;
	  case CM_MODPF: StrID = sth_Modpf; break;
	  case CM_MODVEC: StrID = sth_Modv; break;
	  case CM_MODOT: StrID = sth_Modot; break;
	  case CM_GO: StrID = sth_Go; break;
	  case CM_GOCONT: StrID = sth_Gocont; break;
	  case CM_STEP: StrID = sth_Step; break;
	  case CM_PASO: StrID = sth_Paso; break;
	  case CM_STOPAT: StrID = sth_Stopat; break;
	  case CM_STOPIN: StrID = sth_Stopin; break;
	  case CM_STOPDE: StrID = sth_Stopde; break;
	  case CM_PARAR: StrID = sth_Parar; break;
	  case CM_ACT: StrID = sth_Act; break;
	  case CM_ENCA: StrID = sth_Encade; break;
	  case IDM_UNDO: StrID = sth_EditUndo; break;
          case IDM_CUT: StrID = sth_EditCut; break;
          case IDM_COPY: StrID = sth_EditCopy; break;
          case IDM_PASTE: StrID = sth_EditPaste; break;
          case IDM_CLEAR: StrID = sth_EditClear; break;
	  case IDM_BORR: StrID = sth_EditDelete; break;
          case IDM_MOSA: StrID = sth_WindowTile; break;
          case IDM_CASC: StrID = sth_WindowCascade; break;
          case IDM_REDI: StrID = sth_WindowArrange; break;
	  case IDM_CERR: StrID = sth_WindowCloseAll; break;
	  case CM_SAVESTATE: StrID = sth_SalvarE; break;
	  case CM_RESTORESTATE: StrID = sth_Restaura; break;
	  case IDM_BUSC: StrID = sth_Buscar; break;
	  case IDM_REEM: StrID = sth_Reempl; break;
	  case IDM_SIGU: StrID = sth_Siguiente; break;
	  case IDM_IRA: StrID = sth_Ira; break;
	  case IDM_HELP_INDEX: StrID = sth_HelpIndex; break;
          case IDM_HELP_KEYBOARD: StrID = sth_Teclado; break;
	  case IDM_HELP_HELP: StrID = sth_HelpUsing; break;
	  case IDM_ABOUT: StrID = sth_HelpAbout; break;
	  case CM_SISTEMA: StrID = sth_Sistema; break;
	  case IDM_VEN1:
	  case IDM_VEN2:
	  case IDM_VEN3:
	  case IDM_VEN4:
	  case IDM_VEN5:
	  case IDM_VEN6:
	  case IDM_VEN7:
	  case IDM_VEN8:
	  case IDM_VEN9: StrID = sth_Ventana; break;
	  case IDM_VEN0: StrID = sth_VentMen; break;
	  case IDM_REST: StrID = sth_VentRes; break;
	  case IDM_MOVE: StrID = sth_Mover; break;
	  case IDM_CAMB: StrID = sth_Cambi; break;
	  case IDM_TAMA: StrID = sth_Tama; break;
	  case IDM_SALI: StrID = sth_Cerr; break;
	  case IDM_MINI: StrID = sth_Mini; break;
	  case IDM_MAXI: StrID = sth_Maxi; break;
	  case CM_FUENTES: StrID = sth_Fuen; break;
	  case CM_FILEPRINTERSETUP: StrID = sth_Fs; break;
	  case CM_FILEPRINT: StrID = sth_Fp; break;
	  case CM_SALCAR: StrID = sth_FileSaveLoad; break;
//Marzo 98
          case CM_EXREG: StrID = sth_Regs; break;
	  case CM_EXFP: StrID = sth_FPRegs; break;
	  case CM_EXDFP: StrID = sth_DFPRegs; break;
	  case CM_EXSP: StrID = sth_SPRegs; break;
	  case CM_BORRARAUTO: StrID = sth_BorrarAuto; break;
	  case CM_BORRAREGSAUTO: StrID = sth_BorraRegsAuto; break;

	  default:
                return;
        }
  }
  else
  if (CurrentPopup)
  {
        switch(GetMenuItemID(CurrentPopup, 0))
        {
          case FileFirst: StrID = sth_File; break;
          case EditFirst: StrID = sth_Edit; break;
	  case WindowFirst: StrID = sth_Window; break;
          case SimulFirst: StrID = sth_SimulFirst; break;
	  case EjecuFirst: StrID = sth_EjecuFirst; break;
	  case BuscaFirst: StrID = sth_Busq; break;
	  case BorraFirst: StrID = sth_Borra; break;
	  case CargaFirst: StrID = sth_Carga; break;
	  case ExaFirst: StrID = sth_Exam; break;
	  case ModiFirst: StrID = sth_Modi; break;
	  case StopFirst: StrID = sth_Stop; break;
	  case HelpFirst: StrID = sth_Help; break;
          case SysFirst: StrID = sth_Syst; break;
          default: return;
        }
  }

  DC = GetDC(hWindow);
  BlastStatusLine(hWindow, DC);
  if ((CurrentPopup) || (CurrentID != 0))
  {
	LOGFONT lf;
        HFONT   hSmall, hOld;
        int     TextHeight;


	hOld = (HFONT) GetStockObject( ANSI_VAR_FONT);
        if ( hOld)
        {
                GetObject( hOld, sizeof( LOGFONT), (LPSTR) &lf);
		if ( lf.lfHeight > 3)
		  lf.lfHeight -= 3;
		lf.lfWidth = 0;
		lf.lfWeight = FW_BOLD;
                hSmall = CreateFontIndirect( &lf);
        }
        else
                hSmall = 0;
        if ( hSmall)
                hOld = (HFONT) SelectObject( DC, hSmall);
        else
                hOld = 0;

	LoadString(hInst, StrID, Str, sizeof(Str));
	GetClientRect(hWindow, &Rect);
	SetBkColor(DC, RGB(192, 192, 192));
        TextHeight = (int) HIWORD( GetTextExtent( DC, Str, 1) );
	TextOut(DC, 10,
	  Rect.bottom - StatusLineHeight + ( ( StatusLineHeight - TextHeight) / 2),
          Str, strlen(Str));
        if ( hOld)
                SelectObject( DC, hOld);
        if ( hSmall)
		DeleteObject( hSmall);

	memDC = CreateCompatibleDC(DC);
	oldBmp = SelectObject(memDC, bmpStatusBar);

	BitBlt(DC, Rect.right - 22, Rect.bottom - 22,
					22, 22, memDC, 0, 0, SRCCOPY);
	SelectObject(memDC, oldBmp);

	DeleteDC(memDC);
  }
  ReleaseDC(hWindow, DC);
}

void TNFileW::Ira(int especial)
{
  int numero,numl;

  numl = Editor->GetNumLines();
  if (especial == 0)
  {
  if ( GetModule()->ExecDialog(
       new TLineaDlg(this, "LINE", numl)) == IDOK )
       {
       numero = Editor->GetLineIndex(linea);
       Editor->SetSelection(numero, numero);
       }
  }
  else
  {
  numero = Editor->GetLineIndex(especial);
  Editor->SetSelection(numero, numero);
  }
}

void TNFileW::IrLinea(TMessage&)
{
 Ira(0);
}


TLineaDlg::TLineaDlg(PTWindowsObject AParent, LPSTR name, int numl)
		 :TDialog(AParent, name)
{
  lineas = numl;
  TransferBuffer= &argum;
}

BOOL TLineaDlg::CanClose()
{
   linea=GetDlgItemInt(HWindow, ID_DOS1, NULL, 0);
   if ((linea==0) || (linea>lineas)) {
	wsprintf(salidas,"Incorrect Number of Line.\nMust be in Range (1-%d)",lineas);
	BWCCMessageBox(HWindow, salidas, "Error", MB_OK | MB_ICONEXCLAMATION);
	return FALSE;
	}
   linea--;
   return TRUE;
}

struct InfoSisRecord
{
	char ModoOperacion[ 31 ];
	char TipoCPU[ 31 ];
	char Coprocesador[ 31 ];
	char Global[ 31 ];
	char VersionDos[ 31 ];
}TransferRecord;



TVentanaInfoSis::TVentanaInfoSis( PTWindowsObject AParent, LPSTR name ) :
	TDialog( AParent, name )
{
  PTStatic TempStatic;
  DWORD FlagSis;
  char tempstr[ 31 ];
  WORD ArguList[ 2 ];
  DWORD Disponible;

 
	TempStatic = new TStatic( this, ID_OPERATIONMODE, sizeof( TransferRecord.ModoOperacion ) );
      TempStatic->EnableTransfer();

	TempStatic = new TStatic( this, ID_CPUTYPE, sizeof( TransferRecord.TipoCPU ) );
      TempStatic->EnableTransfer();

	TempStatic = new TStatic( this, ID_COPROCESSOR, sizeof( TransferRecord.Coprocesador ) );
      TempStatic->EnableTransfer();

	TempStatic = new TStatic( this, ID_GLOBAL, sizeof( TransferRecord.Global ) );
      TempStatic->EnableTransfer();

	TempStatic = new TStatic( this, ID_VERSIONDOS, sizeof( TransferRecord.VersionDos ) );
      TempStatic->EnableTransfer();

      FlagSis = GetWinFlags();

	if ( FlagSis & WF_ENHANCED )
		LoadString( hInst, ID_ENHANCED, tempstr, sizeof( tempstr ) );
	else if ( FlagSis & WF_STANDARD )
		LoadString( hInst, ID_STANDARD, tempstr, sizeof( tempstr ) );
	else if ( FlagSis & WF_PMODE )
		LoadString( hInst, ID_REAL, tempstr, sizeof( tempstr ) );
	else
		LoadString( hInst, ID_UNKNOWN, tempstr, sizeof( tempstr ) );
	strcpy( TransferRecord.ModoOperacion, tempstr );

	if ( FlagSis & WF_CPU086 )
		LoadString( hInst, ID_CPU8086, tempstr, sizeof( tempstr ) );
	else if ( FlagSis & WF_CPU186 )
		LoadString( hInst, ID_CPU80186, tempstr, sizeof( tempstr ) );
	else if ( FlagSis & WF_CPU286 )
		LoadString( hInst, ID_CPU80286, tempstr, sizeof( tempstr ) );
	else if ( FlagSis & WF_CPU386 )
		LoadString( hInst, ID_CPU80386, tempstr, sizeof( tempstr ) );
	else if ( FlagSis & WF_CPU486 )
		LoadString( hInst, ID_CPU80486, tempstr, sizeof( tempstr ) );
	else
		LoadString( hInst, ID_UNKNOWN, tempstr, sizeof( tempstr ) );
	strcpy( TransferRecord.TipoCPU, tempstr );

	if ( FlagSis & WF_80x87 )
		LoadString( hInst, ID_YES, tempstr, sizeof( tempstr ) );
	else
		LoadString( hInst, ID_NO, tempstr, sizeof( tempstr ) );
	strcpy( TransferRecord.Coprocesador, tempstr );

	Disponible = GetFreeSpace( 0 ) / 1024;
	ArguList[0] = LOWORD( Disponible );
	ArguList[1] = HIWORD( Disponible );
	wvsprintf( (LPSTR) TransferRecord.Global, (LPSTR) "%lu", (LPSTR) ArguList );

	ArguList[0] = _osmajor;
	ArguList[1] = _osminor;
	wvsprintf( (LPSTR) TransferRecord.VersionDos, (LPSTR) "%d.%d", (LPSTR) ArguList );

	TransferBuffer = (LPSTR) &TransferRecord;
}

TVariabDlg::TVariabDlg(PTWindowsObject AParent, LPSTR name)
		 :TDialog(AParent, name)
{
  new TEdit(this, ID_SumNum, sizeof(TransfPVar.us));
  new TEdit(this, ID_SumLat, sizeof(TransfPVar.ls));

  new TEdit(this, ID_DivNum, sizeof(TransfPVar.ud));
  new TEdit(this, ID_DivLat, sizeof(TransfPVar.ld));

  new TEdit(this, ID_MultNum, sizeof(TransfPVar.um));
  new TEdit(this, ID_MultLat, sizeof(TransfPVar.lm));

  new TEdit(this, ID_SumVNum, sizeof(TransfPVar.usv));
  new TEdit(this, ID_SumVLat, sizeof(TransfPVar.lsv));

  new TEdit(this, ID_DivVNum, sizeof(TransfPVar.udv));
  new TEdit(this, ID_DivVLat, sizeof(TransfPVar.ldv));

  new TEdit(this, ID_MultVNum, sizeof(TransfPVar.umv));
  new TEdit(this, ID_MultVLat, sizeof(TransfPVar.lmv));
  new TEdit(this, ID_LogVNum, sizeof(TransfPVar.ugv));
  new TEdit(this, ID_LogVLat, sizeof(TransfPVar.lgv));
  new TEdit(this, ID_PLec, sizeof(TransfPVar.vrports));
  new TEdit(this, ID_PEsc, sizeof(TransfPVar.vwports));
  new TEdit(this, ID_Memoria, sizeof(TransfPVar.memo));
  new TEdit(this, ID_Bancos, sizeof(TransfPVar.banc));
  new TEdit(this, ID_DOS1, sizeof(TransfPVar.llv));

  TransferBuffer= &TransfPVar;
}

BOOL TVariabDlg::Poten2(long int numero)
{ long int resto;

 resto = numero % 2;
 numero = numero/2;
 while ((numero!=1) && (numero!=0) && (resto == 0)) {resto = numero % 2;
				   numero = numero/2;}
 if ((resto == 0) && (numero == 1)) return TRUE;
	else return FALSE;
}
 


BOOL TVariabDlg::CanClose()
{
   BOOL aux;
   char auxi[lng2];


   us=GetDlgItemInt(HWindow, ID_SumNum, NULL, 0);
   ls=GetDlgItemInt(HWindow, ID_SumLat, NULL, 0);

   ud=GetDlgItemInt(HWindow, ID_DivNum, NULL, 0);
   ld=GetDlgItemInt(HWindow, ID_DivLat, NULL, 0);

   um=GetDlgItemInt(HWindow, ID_MultNum, NULL, 0);
   lm=GetDlgItemInt(HWindow, ID_MultLat, NULL, 0);

   usv=GetDlgItemInt(HWindow, ID_SumVNum, NULL, 0);
   lsv=GetDlgItemInt(HWindow, ID_SumVLat, NULL, 0);

   udv=GetDlgItemInt(HWindow, ID_DivVNum, NULL, 0);
   ldv=GetDlgItemInt(HWindow, ID_DivVLat, NULL, 0);

   umv=GetDlgItemInt(HWindow, ID_MultVNum, NULL, 0);
   lmv=GetDlgItemInt(HWindow, ID_MultVLat, NULL, 0);

   ugv=GetDlgItemInt(HWindow, ID_LogVNum, NULL, 0);
   lgv=GetDlgItemInt(HWindow, ID_LogVLat, NULL, 0);

   vrp=GetDlgItemInt(HWindow, ID_PLec, NULL, 0);
   vwp=GetDlgItemInt(HWindow, ID_PEsc, NULL, 0);

   GetDlgItemText(HWindow, ID_Memoria, auxi, lng2);
   memo=atol(auxi);

   banc=GetDlgItemInt(HWindow, ID_Bancos, NULL, 0);
   llv=GetDlgItemInt(HWindow, ID_DOS1, NULL, 0);

   if ((vrp < 1)||(vwp < 1)){
       BWCCMessageBox(HWindow, "Number must be greater then Zero",
       "Data Error", MB_OK | MB_ICONEXCLAMATION);
       return FALSE;
       }

   if (banc < llv){
       BWCCMessageBox(HWindow, "Number of Banks must be greater then Access Time",
       "Data Error", MB_OK | MB_ICONEXCLAMATION);
       return FALSE;
       }
   if ((banc < 1) || (llv < 1)){
       BWCCMessageBox(HWindow, "Nubmer of Banks and Access Time must be greater then Zero",
       "Data Error", MB_OK | MB_ICONEXCLAMATION);
       return FALSE;
       }
   if (!Poten2(banc)) {
       BWCCMessageBox(HWindow, "Number of Banks must be Exponentiation of Two",
       "Data Error", MB_OK | MB_ICONEXCLAMATION);
       return FALSE;
       }
   if (banc > MAX_MM) {
        wsprintf(salidas, "Number of Banks can't be greater then %ld", MAX_MM);
	BWCCMessageBox(HWindow, salidas, "Data Error",MB_OK | MB_ICONEXCLAMATION);
       return FALSE;
       }
   if (ValidNum(us) && ValidNum(ud)
       && ValidNum(um) && ValidNum(usv)
       && ValidNum(udv) && ValidNum(umv)
       && ValidNum(ugv))
       { aux=TRUE; }
       else {
	      wsprintf(salidas, "Number of Units must be in range (1-%d)",MAX_FP_UNITS);
	      BWCCMessageBox(HWindow, salidas, "Data Error",MB_OK | MB_ICONEXCLAMATION);
	      return FALSE;
	    }
   if (ValidLat(ls) && ValidLat(ld)
       && ValidLat(lm) && ValidLat(lsv)
       && ValidLat(ldv) && ValidLat(lmv)
       && ValidLat(lgv) && aux)
       {aux=TRUE;}
       else {BWCCMessageBox(HWindow,"Latency must be greater then 1", "Data Error",MB_OK | MB_ICONEXCLAMATION);
	     return FALSE;
	     }
   if (ValidMem(memo) && aux)
       { return TRUE;}
       else {wsprintf(salidas, "Memory size must be in range (1-%ld)", MAXLONG);
	     BWCCMessageBox(HWindow, salidas, "Data Error",MB_OK | MB_ICONEXCLAMATION);
	     return FALSE;}
}


BOOL TVariabDlg::ValidNum(long int num)
{
  if ( num < 1 || num > MAX_FP_UNITS)
  {
    return FALSE;
  }
  return TRUE;
}

BOOL TVariabDlg::ValidMem(long int num)
{
  if ( num < 1 )
  {
    return FALSE;
  }
  return TRUE;
}


BOOL TVariabDlg::ValidLat(long int num)
{
  if ( num < 1 )
  {
    return FALSE;
  }
  return TRUE;
}

TEnsDlg::TEnsDlg(PTWindowsObject AParent, LPSTR name)
		 :TDialog(AParent, name)
{
  new TEdit(this, ID_DOS1, largus);
  new TEdit(this, ID_DOS3, largus);
  CheckBox = new TCheckBox(this, ID_DOS2, NULL);

  TransferBuffer= &PEnsVar;
}

BOOL TEnsDlg::CanClose()
{ 
   GetDlgItemText(HWindow, ID_DOS1, prueba, largus);
   if (strcmp(prueba, "") == 0)
    { BWCCMessageBox(HWindow, "You must enter an Instruction", "Data Error", MB_OK | MB_ICONEXCLAMATION);
      return FALSE;
    }
   strcpy(argumentos[1], prueba);
   numarg = 2;
   cuenta = CheckBox->GetCheck();
    if (cuenta==BF_CHECKED)
      {GetDlgItemText(HWindow, ID_DOS3, prueba, largus);
       strcpy(argumentos[2], prueba);
       numarg=3;}
   delete CheckBox;
   return TRUE;
}

TStopatDlg::TStopatDlg(PTWindowsObject AParent, LPSTR name)
		 :TDialog(AParent, name)
{
  new TEdit(this, ID_DOS1, largus);
  new TEdit(this, ID_DOS3, largus);
  CheckBox = new TCheckBox(this, ID_DOS2, NULL);

  TransferBuffer= &PEnsVar;
}

BOOL TStopatDlg::CanClose()
{
   GetDlgItemText(HWindow, ID_DOS1, prueba, largus);
   if (strcmp(prueba, "") == 0)
    { BWCCMessageBox(HWindow, "You must enter the Position", "Data Error", MB_OK | MB_ICONEXCLAMATION);
      return FALSE;
    }
   strcpy(argumentos[2], prueba);
   numarg = 3;
   cuenta = CheckBox->GetCheck();
    if (cuenta==BF_CHECKED)
      {GetDlgItemText(HWindow, ID_DOS3, prueba, largus);
       strcpy(argumentos[3], prueba);
       numarg=4;}
   delete CheckBox;
   return TRUE;
}

TRunDlg::TRunDlg(PTWindowsObject AParent, LPSTR name)
		 :TDialog(AParent, name)
{
  new TEdit(this, ID_DOS3, largus);
  CheckBox = new TCheckBox(this, ID_DOS2, NULL);

  TransferBuffer= &P1EnsVar;
}

void TRunDlg::SetupWindow()
{
 TDialog::SetupWindow();
 CheckBox->SetCheck(BF_CHECKED);
}

BOOL TRunDlg::CanClose()
{
   numarg = 1;
   cuenta = CheckBox->GetCheck();
    if (cuenta==BF_CHECKED)
      {GetDlgItemText(HWindow, ID_DOS3, prueba, largus);
       if (strcmp(prueba, "") == 0)
	{ BWCCMessageBox(HWindow, "You must enter the Position", "Data Error", MB_OK | MB_ICONEXCLAMATION);
	  return FALSE;
	}
       strcpy(argumentos[1], prueba);
       numarg=2;}
   delete CheckBox;
   return TRUE;
}

TEstDlg::TEstDlg(PTWindowsObject AParent, LPSTR name)
		 :TDialog(AParent, name)
{
  CheckBox1 = new TCheckBox(this, ID_DOS1, NULL);
  CheckBox2 = new TCheckBox(this, ID_DOS2, NULL);
  CheckBox3 = new TCheckBox(this, ID_DOS3, NULL);
  CheckBox4 = new TCheckBox(this, ID_DOS4, NULL);
  CheckBox5 = new TCheckBox(this, ID_DOS5, NULL);
  CheckBox6 = new TCheckBox(this, ID_DOS6, NULL);
  CheckBox7 = new TCheckBox(this, ID_DOS7, NULL);
}

void TEstDlg::SetupWindow()
{
 TDialog::SetupWindow();
 CheckBox2->SetCheck(BF_CHECKED);
}

BOOL TEstDlg::CanClose()
{
   numarg = 1;
   cuenta = CheckBox1->GetCheck();
   if (cuenta==BF_CHECKED)
      {strcpy(argumentos[1], "r");
       numarg=2;
       delete CheckBox1;
       delete CheckBox2;
       delete CheckBox3;
       delete CheckBox4;
       delete CheckBox5;
       delete CheckBox6;
       delete CheckBox7;
       return TRUE;}
       else {cuenta = CheckBox5->GetCheck();
	     if (cuenta==BF_CHECKED)
	     {strcpy(argumentos[1], "a");
	      numarg=2;
	      delete CheckBox1;
	      delete CheckBox2;
	      delete CheckBox3;
	      delete CheckBox4;
	      delete CheckBox5;
	      delete CheckBox6;
	      delete CheckBox7;
	      return TRUE;}
	      else {
	      cuenta = CheckBox2->GetCheck();
	      if (cuenta==BF_CHECKED) {strcpy(argumentos[numarg],"s");
				       numarg++;
				       }
	      cuenta = CheckBox3->GetCheck();
	      if (cuenta==BF_CHECKED) {strcpy(argumentos[numarg],"o");
				       numarg++;
				       }
	      cuenta = CheckBox4->GetCheck();
	      if (cuenta==BF_CHECKED) {strcpy(argumentos[numarg],"p");
				       numarg++;
				       }
	      cuenta = CheckBox6->GetCheck();
	      if (cuenta==BF_CHECKED) {strcpy(argumentos[numarg],"b");
				       numarg++;
				       }
	      cuenta = CheckBox7->GetCheck();
	      if (cuenta==BF_CHECKED) {strcpy(argumentos[numarg],"h");
				       numarg++;
				       }
	      delete CheckBox1;
	      delete CheckBox2;
	      delete CheckBox3;
	      delete CheckBox4;
	      delete CheckBox5;
	      delete CheckBox6;
	      delete CheckBox7;
	      return TRUE;}
	     }
}

TModotDlg::TModotDlg(PTWindowsObject AParent, LPSTR name)
		 :TDialog(AParent, name)
{
  new TEdit(this, ID_DOS1, largus);
  new TEdit(this, ID_DOS2, largus);

  TransferBuffer= &PEnsVar;
}

BOOL TModotDlg::CanClose()
{
  GetDlgItemText(HWindow, ID_DOS1, prueba, largus);
  if (strcmp(prueba, "") == 0)
    { BWCCMessageBox(HWindow, "You must enter the Position", "Data Error", MB_OK | MB_ICONEXCLAMATION);
      return FALSE;
    }
  strcpy(argumentos[1], prueba);
  GetDlgItemText(HWindow, ID_DOS2, prueba, largus);
  strcpy(argumentos[2], prueba);
  numarg=3;
  return TRUE;
}

TExotDlg::TExotDlg(PTWindowsObject AParent, LPSTR name)
		 :TDialog(AParent, name)
{
  new TEdit(this, ID_DOS1, largus);
  new TEdit(this, ID_DOS2, largus);
  CheckBox1 = new TCheckBox(this, ID_DOS3, NULL);
  CheckBox2 = new TCheckBox(this, ID_DOS4, NULL);
  CheckBox3 = new TCheckBox(this, ID_DOS5, NULL);
  CheckBox4 = new TCheckBox(this, ID_DOS6, NULL);
  CheckBox5 = new TCheckBox(this, ID_DOS7, NULL);
  CheckBox6 = new TCheckBox(this, ID_DOS8, NULL);
  CheckBox7 = new TCheckBox(this, ID_DOS9, NULL);
  CheckBox8 = new TCheckBox(this, ID_DOS10, NULL);
  CheckBox9 = new TCheckBox(this, ID_DOS11, NULL);
  CheckBox10 = new TCheckBox(this, ID_DOS12, NULL);
}

void TExotDlg::SetupWindow()
{
 TDialog::SetupWindow();
 CheckBox1->SetCheck(BF_CHECKED);
}

BOOL TExotDlg::CanClose()
{
  GetDlgItemText(HWindow, ID_DOS1, prueba, largus);
  if (strcmp(prueba, "") == 0)
    { BWCCMessageBox(HWindow, "You must enter the Position", "Data Error", MB_OK | MB_ICONEXCLAMATION);
      return FALSE;
    }
  strcpy(argumentos[1], prueba);
  GetDlgItemText(HWindow, ID_DOS2, prueba, largus/8);
  strcpy(argumentos[2], prueba);
  numarg=3;
  cuenta = CheckBox1->GetCheck();
  if (cuenta==BF_CHECKED)
      {_fstrcat(argumentos[2], "x");
      }
  cuenta = CheckBox2->GetCheck();
  if (cuenta==BF_CHECKED)
      {_fstrcat(argumentos[2], "d");
      }
  cuenta = CheckBox3->GetCheck();
  if (cuenta==BF_CHECKED)
      {_fstrcat(argumentos[2], "c");
      }
  cuenta = CheckBox4->GetCheck();
  if (cuenta==BF_CHECKED)
      {_fstrcat(argumentos[2], "v");
      }
  cuenta = CheckBox5->GetCheck();
  if (cuenta==BF_CHECKED)
      {_fstrcat(argumentos[2], "h");
      }
  cuenta = CheckBox6->GetCheck();
  if (cuenta==BF_CHECKED)
      {_fstrcat(argumentos[2], "B");
      }
  cuenta = CheckBox7->GetCheck();
  if (cuenta==BF_CHECKED)
      {_fstrcat(argumentos[2], "i");
      }
  cuenta = CheckBox8->GetCheck();
  if (cuenta==BF_CHECKED)
      {_fstrcat(argumentos[2], "s");
      }
  cuenta = CheckBox9->GetCheck();
  if (cuenta==BF_CHECKED)
      {_fstrcat(argumentos[2], "b");
      }
  cuenta = CheckBox10->GetCheck();
  if (cuenta==BF_CHECKED)
      {_fstrcat(argumentos[2], "w");
      }
  delete CheckBox1;
  delete CheckBox2;
  delete CheckBox3;
  delete CheckBox4;
  delete CheckBox5;
  delete CheckBox6;
  delete CheckBox7;
  delete CheckBox8;
  delete CheckBox9;
  delete CheckBox10;
  return TRUE;
}

void TExotDlg::Continuar(RTMessage)
{
 CloseWindow(IDRETRYM);
}

TPFDlg::TPFDlg(PTWindowsObject AParent, LPSTR name)
		 :TDialog(AParent, name)
{
  new TEdit(this, ID_DOS1, largus);
  new TEdit(this, ID_DOS2, largus);
  RTBut1 = new TRadioButton(this, ID_DOS3, NULL);
  RTBut2 = new TRadioButton(this, ID_DOS4, NULL);

  TransferBuffer= &PEnsVar;
}

void TPFDlg::SetupWindow()
{
 TDialog::SetupWindow();
 RTBut1->SetCheck(BF_CHECKED);
 RTBut2->SetCheck(BF_UNCHECKED);
}

void TPFDlg::Continuar(RTMessage)
{
 CloseWindow(IDRETRYM);
}

BOOL TPFDlg::CanClose()
{
   GetDlgItemText(HWindow, ID_DOS1, prueba, largus);
   if (strcmp(prueba, "") == 0)
    { BWCCMessageBox(HWindow, "You must enter the Position", "Data Error", MB_OK | MB_ICONEXCLAMATION);
      return FALSE;
    }
   strcpy(argumentos[1], prueba);
   GetDlgItemText(HWindow, ID_DOS2, prueba, largus/8);
   strcpy(argumentos[2], prueba);
   numarg = 3;
   cuenta = RTBut1->GetCheck();
    if (cuenta==BF_CHECKED)
      {_fstrcat(argumentos[2], "d");
      }
      else { cuenta = RTBut2->GetCheck();
	     if (cuenta==BF_CHECKED)
		{_fstrcat(argumentos[2], "f");}
	   }
   delete RTBut1;
   delete RTBut2;
   return TRUE;
}

TPutFDlg::TPutFDlg(PTWindowsObject AParent, LPSTR name)
		 :TDialog(AParent, name)
{
  new TEdit(this, ID_DOS1, largus);
  new TEdit(this, ID_DOS2, largus);
  RTBut1 = new TRadioButton(this, ID_DOS3, NULL);
  RTBut2 = new TRadioButton(this, ID_DOS4, NULL);


  TransferBuffer= &PEnsVar;
}

void TPutFDlg::SetupWindow()
{
 TDialog::SetupWindow();
 RTBut1->SetCheck(BF_CHECKED);
}

BOOL TPutFDlg::CanClose()
{
   GetDlgItemText(HWindow, ID_DOS1, prueba, largus);
   if (strcmp(prueba, "") == 0)
    { BWCCMessageBox(HWindow, "You must enter the Position", "Data Error", MB_OK | MB_ICONEXCLAMATION);
      return FALSE;
    }
   strcpy(argumentos[1], prueba);
   GetDlgItemText(HWindow, ID_DOS2, prueba, largus);
   strcpy(argumentos[2], prueba);
   numarg = 3;
   cuenta = RTBut1->GetCheck();
    if (cuenta==BF_CHECKED)
      {strcpy(argumentos[3], "d");
      numarg++;
      }
      else { cuenta = RTBut2->GetCheck();
	     if (cuenta==BF_CHECKED)
		{strcpy(argumentos[3], "f");
		numarg++;}
	   }
   delete RTBut1;
   delete RTBut2;
   return TRUE;
}

void CambiaFuen(Pvoid P, Pvoid)
{
  ((PTEditWindow)P)->Editor->Fuent = Fuen;
  ((PTEditWindow)P)->Editor->nfuente = nfu;
  ((PTEditWindow)P)->Editor->Cambia(TRUE);
}


void TMDIFileWindow::WMFuentes(RTMessage)
{
 ForEach(CambiaFuen, NULL);
}

TFuentesDlg::TFuentesDlg(PTWindowsObject AParent, LPSTR name)
		 :TDialog(AParent, name)
{
  int i;

  for (i=0;i<4;i++){
  RTBut[i] = new TRadioButton(this, ID_DOS + i , NULL);
  }
  CheckBox1 = new TRadioButton(this, ID_DOS4, NULL);
}

void TFuentesDlg::SetupWindow()
{
 TDialog::SetupWindow();
 RTBut[auxbut]->SetCheck(BF_CHECKED);
 CheckBox1->SetCheck(BF_CHECKED);
}

BOOL TFuentesDlg::CanClose()
{
   cuenta = RTBut[0]->GetCheck();
    if (cuenta==BF_CHECKED)
      {
      Fuen = (HFONT) GetStockObject(ANSI_FIXED_FONT);
      auxbut = nfu = 0;
      }
      else { cuenta = RTBut[1]->GetCheck();
	     if (cuenta==BF_CHECKED)
		{
		Fuen = (HFONT) GetStockObject(DEVICE_DEFAULT_FONT);
                auxbut = nfu = 1;
                }
	        else { cuenta = RTBut[2]->GetCheck();
	     		if (cuenta==BF_CHECKED)
			{
			Fuen = (HFONT) GetStockObject(OEM_FIXED_FONT);
                        auxbut = nfu = 2;
			}
	   		else { cuenta = RTBut[3]->GetCheck();
				if (cuenta==BF_CHECKED)
				{
				Fuen = (HFONT) GetStockObject(SYSTEM_FIXED_FONT);
				auxbut = nfu = 3;
				}
	   }
	   }
	   }
   cuenta = CheckBox1->GetCheck();
   if (cuenta == BF_CHECKED) {
	PostMessage(GetWindow(HWindow, GW_OWNER) , WM_FUENTES, 0, 0);
	}
   delete RTBut[0];
   delete RTBut[1];
   delete RTBut[2];
   delete RTBut[3];
   delete CheckBox1;
   return TRUE;
}


TDelDlg::TDelDlg(PTWindowsObject AParent, LPSTR name)
		 :TDialog(AParent, name)
{
  new TEdit(this, ID_DOS1, largus);

  TransferBuffer= &P1EnsVar;
}

BOOL TDelDlg::CanClose()
{ int nivel, i, j, longitud;

   GetDlgItemText(HWindow, ID_DOS1, prueba, largus);
   if (strcmp(prueba, "") == 0)
    { BWCCMessageBox(HWindow, "You must enter number of the Stop Point", "Data Error", MB_OK | MB_ICONEXCLAMATION);
      return FALSE;
    }
   longitud = _fstrlen(prueba);
   nivel = 2;
   j = 0;
   for (i=0;(i<longitud) && (nivel<argus);i++)
   {argumentos[nivel][j] = prueba[i];
    if ((prueba[i] == ' ') || (prueba[i] == ','))
     {argumentos[nivel][j] = '\0';nivel++;j =0;}
     else {j++;}
   }
   if (nivel==argus) {  numarg = nivel;
		     }
   else { argumentos[nivel][j] = '\0';
	  numarg = nivel+1;
	  }
   return TRUE;
}

TTraDlg::TTraDlg(PTWindowsObject AParent, LPSTR name)
		 :TDialog(AParent, name)
{
  new TEdit(this, ID_DOS1, largus);
  RTBut1 = new TRadioButton(this, ID_DOS3, NULL);
  RTBut2 = new TRadioButton(this, ID_DOS4, NULL);

  TransferBuffer= &P1EnsVar;
}

void TTraDlg::SetupWindow()
{
 TDialog::SetupWindow();
 RTBut1->SetCheck(BF_CHECKED);
 RTBut2->SetCheck(BF_UNCHECKED);
}

BOOL TTraDlg::CanClose()
{
   GetDlgItemText(HWindow, ID_DOS1, prueba, largus);

   strcpy(argumentos[2], prueba);
   numarg=1;
   cuenta = RTBut1->GetCheck();
   if (cuenta == BF_CHECKED)
    {if (strcmp(prueba, "") == 0)
      { BWCCMessageBox(HWindow, "You must enter Filename", "Data Error", MB_OK | MB_ICONEXCLAMATION);
	return FALSE;
      }
     strcpy(argumentos[1], "on");
     numarg = 3;
     }
     else{cuenta = RTBut2->GetCheck();
	  if (cuenta == BF_CHECKED)
		{strcpy(argumentos[1], "off");
		 numarg = 2;
		}
	  }
  delete RTBut1;
  delete RTBut2;
  return TRUE;
}

TExavDlg::TExavDlg(PTWindowsObject AParent, LPSTR name)
		 :TDialog(AParent, name)
{
  new TEdit(this, ID_DOS1, largus);
  new TEdit(this, ID_DOS2, largus);

  TransferBuffer= &PEnsVar;
}

void TExavDlg::Continuar(RTMessage)
{
 CloseWindow(IDRETRYM);
}

BOOL TExavDlg::CanClose()
{

   GetDlgItemText(HWindow, ID_DOS1, prueba, largus);
   strcpy(argumentos[1], prueba);
   GetDlgItemText(HWindow, ID_DOS2, prueba, largus/8);
   strcpy(argumentos[2], prueba);
   if (((strcmp(argumentos[1], "") == 0) || (strcmp(argumentos[2], "") == 0)))
    { BWCCMessageBox(HWindow, "Incorrect Parameter", "Data Error", MB_OK | MB_ICONEXCLAMATION);
      return FALSE;
    }
   numarg = 3;
   return TRUE;
}

TElegDlg::TElegDlg(PTWindowsObject AParent, LPSTR name)
		 :TDialog(AParent, name)
{
    RTBut = new TRadioButton(this, ID_DOS, NULL);
    RTBut1 = new TRadioButton(this, ID_DOS1, NULL);
    RTBut2 = new TRadioButton(this, ID_DOS2, NULL);
    RTBut3 = new TRadioButton(this, ID_DOS3, NULL);
    RTBut4 = new TRadioButton(this, ID_DOS4, NULL);
    RTBut5 = new TRadioButton(this, ID_DOS5, NULL);
    RTBut6 = new TRadioButton(this, ID_DOS6, NULL);
    RTBut7 = new TRadioButton(this, ID_DOS7, NULL);
}

BOOL TElegDlg::CanClose()
{
  registro = -1;
  cuenta = RTBut->GetCheck();
  if (cuenta == BF_CHECKED) registro = 0;
  else {
   cuenta = RTBut1->GetCheck();
   if (cuenta == BF_CHECKED) registro = 1;
   else {
     cuenta = RTBut2->GetCheck();
     if (cuenta == BF_CHECKED) registro = 2;
     else {
      cuenta = RTBut3->GetCheck();
      if (cuenta == BF_CHECKED) registro = 3;
      else {
       cuenta = RTBut4->GetCheck();
       if (cuenta == BF_CHECKED) registro = 4;
       else {
	cuenta = RTBut5->GetCheck();
	if (cuenta == BF_CHECKED) registro = 5;
	else {
	 cuenta = RTBut6->GetCheck();
	 if (cuenta == BF_CHECKED) registro = 6;
	 else {
	  cuenta = RTBut7->GetCheck();
	  if (cuenta == BF_CHECKED) registro = 7;
	  }
	 }
	}
       }
      }
     }
    }

   if (registro == -1) { return FALSE;}
    else {
	    delete RTBut;
	    delete RTBut1;
	    delete RTBut2;
	    delete RTBut3;
	    delete RTBut4;
	    delete RTBut5;
	    delete RTBut6;
	    delete RTBut7;
	    return TRUE;
	 }
}

TModVDlg::TModVDlg(PTWindowsObject AParent, LPSTR name)
		 :TDialog(AParent, name)
{ int i;
  wsprintf(prueba, "Modify Vector Register: V%d", registro);
  SetCaption(prueba);
  for (i = ID_DOS; i < ID_DOS64; i++)
  {
    new TEdit(this, i, vec);
  }

  TransferBuffer= &PVect.vector;
}

BOOL TModVDlg::CanClose()
{ int i, j;
  long int value[2];
  double *pd = (double *)&(value[0]);

  for (i = ID_DOS ; i < ID_DOS64; i++)
  {
   j = (i-ID_DOS)*2;
   GetDlgItemText(HWindow, i, prueba, vec);
   *pd = atof(prueba);
   machPtr->vecregs[registro][j] = value[0];
   machPtr->vecregs[registro][j+1] = value[1];
  }

 return TRUE;
}

TIndexDlg::TIndexDlg(PTWindowsObject AParent, LPSTR name)
		 :TDialog(AParent, name)
{
  new TEdit(this, ID_DOS1, largus);
  new TEdit(this, ID_DOS2, largus);

  TransferBuffer= &PEnsVar;
}

void TIndexDlg::Continuar(RTMessage)
{
 CloseWindow(IDRETRYM);
}

BOOL TIndexDlg::CanClose()
{
   GetDlgItemText(HWindow, ID_DOS1, prueba, largus/10);
   strcpy(argumentos[1], prueba);
   GetDlgItemText(HWindow, ID_DOS2, prueba, largus/10);
   strcpy(argumentos[2], prueba);
   if (((strcmp(argumentos[1], "") == 0) || (strcmp(argumentos[2], "") == 0)))
    { BWCCMessageBox(HWindow, "Incorrect Parameter", "Data Error", MB_OK | MB_ICONEXCLAMATION);
      return FALSE;
    }
   numarg = 3;
   return TRUE;
}


void TMDIFileWindow::rellenar(LPSTR Titulo, LPSTR Temp)
{
	ofnTemp.lStructSize = sizeof( OPENFILENAME );
	ofnTemp.hwndOwner = HWindow;
	ofnTemp.hInstance = hInst;
	ofnTemp.lpstrFilter = (LPSTR)Temp;
	ofnTemp.lpstrCustomFilter = NULL;
	ofnTemp.nMaxCustFilter = 0;
	ofnTemp.nFilterIndex = 1;
	ofnTemp.lpstrFile = (LPSTR)szName;
	ofnTemp.nMaxFile = sizeof( szName );
	ofnTemp.lpstrFileTitle = NULL;
	ofnTemp.nMaxFileTitle = 0;
	ofnTemp.lpstrInitialDir = NULL;
	ofnTemp.lpstrTitle = (LPSTR)Titulo;
	ofnTemp.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_NOCHANGEDIR | OFN_ENABLETEMPLATE;
	ofnTemp.nFileOffset = 0;
	ofnTemp.nFileExtension = 0;
	ofnTemp.lpstrDefExt = "*";
	ofnTemp.lCustData = NULL;
	ofnTemp.lpfnHook = NULL;
	ofnTemp.lpTemplateName = (LPCSTR)"OPEN";
}

void TMDIFileWindow::SetupWindow()
{
   int i;
   HDC DC;

	TMDIFrame::SetupWindow();
	hCursorAyuda = LoadCursor(hInst,"HelpCursor");
	bmpStatusBar = LoadBitmap(hInst, MAKEINTRESOURCE(bmp_StatusBar+1));
	bmpNohabil = LoadBitmap(hInst, "nohabil");
	for (i=0;i<maxbot;i++)
	{Botones[i].bmpa = LoadBitmap(hInst, MAKEINTRESOURCE(i*2+1));
	 Botones[i].bmpb = LoadBitmap(hInst, MAKEINTRESOURCE(i*2+2));
	 Botones[i].habil = 1;
	 Botones[i].accion = acciones[i];
	 Botones[i].x = i*TAMBOTH;
	}

	maxbot = 5;

	DragAcceptFiles( HWindow , TRUE );
	DoSize(HWindow);
	DC = GetDC(HWindow);
	BlastBotones(HWindow, DC);
	ReleaseDC(HWindow, DC);
	PostMessage(HWindow, WM_COMMAND, CM_CREASIM, 0);
	PostMessage(HWindow, WM_COMMAND, CM_SOBRE, 0);
}

void TMDIFileWindow::ShutDownWindow()
{
	DragAcceptFiles( HWindow , FALSE );
	TMDIFrame::ShutDownWindow();
}

void TMDIFileWindow::WMLButtonDown( RTMessage Msg)
{
 int indi;

 indi = LOWORD(Msg.LParam) / TAMBOTH;


 if ((HIWORD(Msg.LParam) < TAMBOTV) && (indi<maxbot) && !Pintado && Botones[indi].habil)
	{
	 HDC DC, memDC;
	 HANDLE oldBmp;

	 
	 DC = GetDC(HWindow);
         memDC = CreateCompatibleDC(DC);
	 oldBmp = SelectObject(memDC, Botones[indi].bmpb);
	 BitBlt(DC, indi*TAMBOTH, 0, TAMBOTH, TAMBOTV, memDC, 0, 0, SRCCOPY);
	 SelectObject(memDC, oldBmp);
	 DeleteDC(memDC);
	 ReleaseDC(HWindow, DC);
	 Pintado = TRUE;
	 BPintado = indi;
	 CurrentID = Botones[indi].accion;
         drawStatusLine(HWindow);
	 Msg.Result = 0;
	}
	else DefWndProc(Msg);
}

void TMDIFileWindow::WMLButtonUp( RTMessage Msg)
{
 int indi;

 indi = LOWORD(Msg.LParam) / TAMBOTH;
 if ((HIWORD(Msg.LParam) < TAMBOTV) && (indi<maxbot) && Pintado)
	{
	 HDC DC, memDC;
	 HANDLE oldBmp;

	 
	 DC = GetDC(HWindow);
         memDC = CreateCompatibleDC(DC);
	 oldBmp = SelectObject(memDC, Botones[indi].bmpa);
	 BitBlt(DC, indi*TAMBOTH, 0, TAMBOTH, TAMBOTV, memDC, 0, 0, SRCCOPY);
	 SelectObject(memDC, oldBmp);
	 DeleteDC(memDC);
	 ReleaseDC(HWindow, DC);
	 Pintado = FALSE;
	 CurrentID = 1;
	 drawStatusLine(HWindow);
	 PostMessage(HWindow, WM_COMMAND, WPARAM(Botones[indi].accion), 0);
	 Msg.Result = 0;
	}
	else DefWndProc(Msg);
}

void TMDIFileWindow::WMNCMouseMove( RTMessage Msg)
{
 if (Pintado)
	{
	 HDC DC, memDC;
	 HANDLE oldBmp;

	 DC = GetDC(HWindow);
         memDC = CreateCompatibleDC(DC);
	 oldBmp = SelectObject(memDC, Botones[BPintado].bmpa);
	 BitBlt(DC, BPintado*TAMBOTH, 0, TAMBOTH, TAMBOTV, memDC, 0, 0, SRCCOPY);
	 SelectObject(memDC, oldBmp);
	 DeleteDC(memDC);
	 ReleaseDC(HWindow, DC);
	 Pintado = FALSE;
	 CurrentID = 1;
	 drawStatusLine(HWindow);
	 Msg.Result = 0;
	}
	else DefWndProc(Msg);
}

void TMDIFileWindow::WMMouseMove( RTMessage Msg)
{
 int x;

 x = LOWORD(Msg.LParam);
 if ( (HIWORD(Msg.LParam) < TAMBOTV) && ((x>(BPintado+1)*TAMBOTH) || (x<BPintado*TAMBOTH)) && Pintado)
	{
	 HDC DC, memDC;
	 HANDLE oldBmp;

	 DC = GetDC(HWindow);
         memDC = CreateCompatibleDC(DC);
	 oldBmp = SelectObject(memDC, Botones[BPintado].bmpa);
	 BitBlt(DC, BPintado*TAMBOTH, 0, TAMBOTH, TAMBOTV, memDC, 0, 0, SRCCOPY);
	 SelectObject(memDC, oldBmp);
	 DeleteDC(memDC);
	 ReleaseDC(HWindow, DC);
	 Pintado = FALSE;
	 CurrentID = 1;
	 drawStatusLine(HWindow);
	 Msg.Result = 0;
	}
	else DefWndProc(Msg);
}

void TMDIFileWindow::WMDropFiles( RTMessage msg )
{
	HDROP hDrop = (HDROP)msg.WParam;
	int TotalNumberOfFiles = DragQueryFile( hDrop , 0xFFFF, NULL, 0 );


	for ( int i = 0; i < TotalNumberOfFiles ; i++ )
	{
		int nFileLength  = DragQueryFile( hDrop , i , NULL, 0 );

		char *pszFileName = new char [ nFileLength + 1];

		DragQueryFile( hDrop , i, pszFileName, nFileLength + 1 );

		wsprintf(ChildName,"DLXVSIM %d", ChildNum++);
		GetApplication()->MakeWindow(new TNFileW(this, ChildName, pszFileName, Fuen, nfu));

	}
	DragFinish( hDrop );
}

TMDIFileWindow::TMDIFileWindow(LPSTR ATitle, LPSTR MenuName)
		   : TMDIFrame(ATitle, MenuName)
{
  Attr.X = GetSystemMetrics(SM_CXSCREEN) / 18;
  Attr.Y = GetSystemMetrics(SM_CYSCREEN) / 18;
  Attr.H = Attr.Y * 16;
  Attr.W = Attr.X * 16;
  Attr.Style |= CS_BYTEALIGNCLIENT;
  ChildNum = 1;
  maxbot = MBOT;
  Printer = new TPrinter;
}

TMDIFileWindow::~TMDIFileWindow( void )
{
    delete Printer;
}

void TMDIFileWindow::GetWindowClass(WNDCLASS& AWndClass)
{
  TMDIFrame::GetWindowClass(AWndClass);
  AWndClass.style |= CS_BYTEALIGNCLIENT;
  AWndClass.hIcon = LoadIcon(GetApplication()->hInstance, "DLXVSIM");
}

void TMDIFileWindow::AyudaIndice(RTMessage)
{
 WinHelp(HWindow,NombreAyuda,HELP_INDEX,0L);
}

void TMDIFileWindow::AyudaTeclado(RTMessage)
{
WinHelp(HWindow,NombreAyuda,HELP_KEY,(DWORD)(LPSTR)"Keyboard");
}

void TMDIFileWindow::AyudaAyuda(RTMessage)
{
WinHelp(HWindow,"WINHELP.HLP",HELP_INDEX,0L);
}

void TMDIFileWindow::NewFile(RTMessage)
{
  wsprintf(ChildName,"DLXVSIM %d", ChildNum++);
  GetApplication()->MakeWindow(new TNFileW(this, ChildName, "", Fuen, nfu));
}

void TMDIFileWindow::OpeFile(RTMessage)
{
  rellenar((LPSTR)"Open File", (LPSTR)"All Files (*.*)\0*.*\0Patterns (*.s)\0*.s\0");
  wsprintf(ChildName,"DLXVSIM %d", ChildNum++);

  if(GetOpenFileName( &ofnTemp ) != TRUE)
	{       char Errstr[50]="Error in GetOpenFileName #";
		DWORD Errval;
		char buf[5];

		Errval=CommDlgExtendedError();
		if(Errval!=0)
		{
			sprintf(buf,"%ld",Errval);
			_fstrcat(Errstr,buf);
			BWCCMessageBox(HWindow,Errstr,"Warning",MB_OK|MB_ICONSTOP);
		}
	}
	else {GetApplication()->MakeWindow(new TNFileW(this, ChildName, szName, Fuen, nfu));}
}

void TMDIFileWindow::SaveState(RTMessage)
{
  ofpstream os(DskFile);

  PutChildren(os);
  os.close();

  if ( os.bad() )
  {
    unlink(DskFile);
    BWCCMessageBox(HWindow, "Cannot save file.", "Disc Error",
      MB_OK | MB_ICONEXCLAMATION);
  }
}

void DoCreateChild(Pvoid P, Pvoid)
{
  if ( ((PTWindowsObject)P)->IsFlagSet(WB_AUTOCREATE) )
    ((PTWindowsObject)P)->Create();
}

// Extraer los argumentos de la ventana a actualizar
void extraer()
{
 int j, indi=0;
 int longitud;


 numarg = 1;
 longitud = _fstrlen(titulo);
 for (j=11;j<longitud;j++)
  {if (isspace(titulo[j])) {argumentos[numarg][indi] = '\0';
			   numarg++;
			   indi=0;
			 }
      else {if (titulo[j] == ')') {continue;}
	    else {argumentos[numarg][indi] = titulo[j];
		  indi++;
		  }
	    }
   }
}

void DoActualiza(Pvoid P, Pvoid)
{
 int x, y, lineax, lineay, caracx, caracy;

  if ( ((PTWindowsObject)P)->IsFlagSet(WB_MDICHILD) )
    {if (((PTWindowsObject)P)->Title[3] == 'o')
      {((PTEditWindow)P)->Editor->GetSelection(x,y);
       ((PTNFileW)P)->Readp(x+longitud+1, y+longitud+1);
       longitud = -1;
       }
     else{
     if (((((PTWindowsObject)P)->Title[3] == 'm') || (((PTWindowsObject)P)->Title[2] == 't')) && (actual))
      {((PTEditWindow)P)->Editor->GetSelection(x,y);
       lineax = ((PTEditWindow)P)->Editor->GetLineFromPos(x);
       lineay = ((PTEditWindow)P)->Editor->GetLineFromPos(y);
       caracx = x - ((PTEditWindow)P)->Editor->GetLineIndex(lineax);
       caracy = y - ((PTEditWindow)P)->Editor->GetLineIndex(lineay);
       strcpy(titulo, ((PTWindowsObject)P)->Title);
       extraer();
       switch (((PTWindowsObject)P)->Title[8]) {
	case 'P': //Examinar Punto Flotante
	 strcpy(argumentos[0], "fget");
	 Gp_FGetCmd(machPtr, numarg, argumentos);
	 if (*machPtr->result != 0) {
	  ((PTEditWindow)P)->Editor->SetText((LPSTR)machPtr->result);
	  x = ((PTEditWindow)P)->Editor->GetLineIndex(lineax) + caracx;
	  y = ((PTEditWindow)P)->Editor->GetLineIndex(lineay) + caracy;
	  ((PTEditWindow)P)->Editor->SetSelection(x,y);
	  machPtr->result[0] ='\0';
	  }
	 break;
	case 'O': //Examinar Otros
	 strcpy(argumentos[0], "get");
	 Gp_GetCmd(machPtr, numarg, argumentos);
	 if (*machPtr->result != 0) {
	  ((PTEditWindow)P)->Editor->SetText((LPSTR)machPtr->result);
	  x = ((PTEditWindow)P)->Editor->GetLineIndex(lineax) + caracx;
	  y = ((PTEditWindow)P)->Editor->GetLineIndex(lineay) + caracy;
	  ((PTEditWindow)P)->Editor->SetSelection(x,y);
	  machPtr->result[0] ='\0';
	  }
	  break;
	case 'V': //Examinar Vectorial
	 strcpy(argumentos[0], "vget");
	 Gp_Vget(machPtr, argumentos);
	 if (*machPtr->result != 0) {
	  ((PTEditWindow)P)->Editor->SetText((LPSTR)machPtr->result);
	  x = ((PTEditWindow)P)->Editor->GetLineIndex(lineax) + caracx;
	  y = ((PTEditWindow)P)->Editor->GetLineIndex(lineay) + caracy;
	  ((PTEditWindow)P)->Editor->SetSelection(x,y);
	  machPtr->result[0] ='\0';
	  }
	 break;
	case 'i': //Estadisticas
	 strcpy(argumentos[0], "stats");
	 Sim_DumpStats(machPtr, numarg, argumentos);
	 ((PTNFileW)P)->Readp(x,y);
	 break;
	case 'C': //PC Indexado
	 strcpy(argumentos[0], "pcget");
	 Gp_PCindex(machPtr, argumentos);
	 if (*machPtr->result != 0) {
	  ((PTEditWindow)P)->Editor->SetText((LPSTR)machPtr->result);
	  x = ((PTEditWindow)P)->Editor->GetLineIndex(lineax) + caracx;
	  y = ((PTEditWindow)P)->Editor->GetLineIndex(lineay) + caracy;
	  ((PTEditWindow)P)->Editor->SetSelection(x,y);
	  machPtr->result[0] ='\0';
	  }
	 break;
	 }
      }
    }
  }
}

void DoPresente(Pvoid P, Pvoid)
{
 int sacar=FALSE;
 int x, y;

  if ( ((PTWindowsObject)P)->IsFlagSet(WB_MDICHILD) )
    {
    switch (ventana) {
    case vestadi:if ((((PTWindowsObject)P)->Title[3] == 'a') &&
		 (((PTWindowsObject)P)->Title[4] == 'd'))
		 {((PTWindowsObject)P)->SetCaption(titulo);
		 ((PTNFileW)P)->SetFileName("Estad.tmp");
		 sacar = TRUE;presente = TRUE;}
		 break;
    case vensamb:if ((((PTWindowsObject)P)->Title[3] == 'a') &&
		 (((PTWindowsObject)P)->Title[4] == 'm'))
		 {sacar = TRUE;presente = TRUE;}break;
    case vcargar:if (((PTWindowsObject)P)->Title[3] == 'g')
		 {sacar = FALSE;presente = TRUE;
		  SendMessage(((PTWindowsObject)P)->Parent->GetClient()->HWindow, WM_MDIACTIVATE, (WPARAM) (HWND)((PTWindowsObject)P)->HWindow, 0);
		 }
		 break;
    case vmodifF:if ((((PTWindowsObject)P)->Title[3] == 'i') &&
		 (((PTWindowsObject)P)->Title[10] == 'F'))
		 {sacar = TRUE;presente = TRUE;}break;
    case vmodifT:if ((((PTWindowsObject)P)->Title[3] == 'i') &&
		 (((PTWindowsObject)P)->Title[10] == 'T'))
		 {sacar = TRUE;presente = TRUE;}break;
    case vejecut:if (((PTWindowsObject)P)->Title[3] == 'c')
		 {sacar = TRUE;presente = TRUE;}break;
    case vstopat:if ((((PTWindowsObject)P)->Title[3] == 'p') &&
		 (((PTWindowsObject)P)->Title[5] == 'a'))
		 {sacar = TRUE;presente = TRUE;}break;
    case vstopin:if ((((PTWindowsObject)P)->Title[3] == 'p') &&
		 (((PTWindowsObject)P)->Title[5] == 'i'))
		 {sacar = TRUE;presente = TRUE;}break;
    case vstopde:if ((((PTWindowsObject)P)->Title[3] == 'p') &&
		 (((PTWindowsObject)P)->Title[5] == 'd'))
		 {sacar = TRUE;presente = TRUE;}break;
    case vdinero:if (((PTWindowsObject)P)->Title[3] == 'e')
		 {sacar = TRUE;presente = TRUE;}break;
    case vindice:if ((((PTWindowsObject)P)->Title[3] == 'm') &&
		    (((PTWindowsObject)P)->Title[8] == 'C'))
		 {sacar = FALSE;presente = TRUE;}break;
    case vpaso:  if (((PTWindowsObject)P)->Title[3] == 'o')
		 {sacar = FALSE;presente = TRUE;}break;
    case vexam:  if (((PTWindowsObject)P)->Title[3] == 'm')
		 {
		  if (strcmp(titulo, ((PTWindowsObject)P)->Title) == 0)
		  {sacar = TRUE;presente = TRUE;}}
		 break;
    }
    if (sacar) {((PTEditWindow)P)->Editor->GetSelection(x,y);
		((PTNFileW)P)->Readp(x,y);
		SendMessage(((PTWindowsObject)P)->Parent->GetClient()->HWindow, WM_MDIACTIVATE, (WPARAM) (HWND)((PTWindowsObject)P)->HWindow, 0);
		}
}
}

void DoVentana(Pvoid P, Pvoid)
{
if ( ((PTWindowsObject)P)->IsFlagSet(WB_MDICHILD) )
    {

     if (lstrcmpi(((PTWindowsObject)P)->Title, "Check") == 0)
	{
	Ventana->Lista->ClearList();
	}
     }
}

void TMDIFileWindow::Limpia()
{
 ForEach(DoVentana, NULL);
}

void DoErrores(Pvoid P, Pvoid)
{
 int x;

  if ( ((PTWindowsObject)P)->IsFlagSet(WB_MDICHILD) )
    {

     x = lstrcmpi(((PTWindowsObject)P)->Title, "Check");

     if (x != 0)
	{

	GetWindowText(((PTFileWindow)P)->HWindow, salidas, TAMSEL);
	if (_fstrstr(salidas, Ventana->Fichero) != NULL)
	{
	 int error;

	 SendMessage(((PTWindowsObject)P)->Parent->GetClient()->HWindow, WM_MDIACTIVATE, (WPARAM)(HWND)((PTWindowsObject)P)->HWindow, 0L);
	 presente = TRUE;
	 error = ((PTNFileW)P)->Editor->Search(0, salidas, TRUE);
// Este codigo produce una "transgresion" de la integridad del sistema
// El problema esta en que algunos mensajes de error no llevan >=
// Y Ventana->Result apunta a la tira que esta a la derecha de >=
// La solucion definitiva seria unificar la generacion de msgs de error.
// Los que dan problemas se generan en sym.c
// Los correctos en asm.c
//	 error = ((PTNFileW)P)->Editor->Search(0, Ventana->Result, TRUE);
	 if (error == -1)
		{((PTNFileW)P)->Ira(Ventana->Linea);}
	}
	}
     }
 }

void TMDIFileWindow::RestoreState(RTMessage)
{
  LPSTR ErrorMsg = NULL;

  ifpstream is(DskFile);
  if ( is.bad() )
    ErrorMsg = _fstrdup("Cannot read file");
  else
  {
    if ( CloseChildren() )
    {
      GetChildren(is);
      if ( is.bad() )
	ErrorMsg = _fstrdup("Error in reading file.");
	  if ( GetApplication()->LowMemory() )
      {
	CloseChildren();
	ErrorMsg = _fstrdup("Insufficient memory for open file.");
      }
      else
	ForEach(DoCreateChild, NULL);
    }
  }
  if ( ErrorMsg )
    BWCCMessageBox(HWindow, ErrorMsg, "Disc Error",
				   MB_OK | MB_ICONEXCLAMATION);
}

void TMDIFileWindow::Actualizar()
{
 ForEach(DoActualiza, NULL);
}

void TMDIFileWindow::Presentes()
{
 ForEach(DoPresente, NULL);
}

void TMDIFileWindow::Errores()
{
 ForEach(DoErrores, NULL);
}

void TMDIFileWindow::Variables(RTMessage)
{
  char tex[lng];
  char tex1[lng2];
  int ndig=lng-1, ndig2=lng2-1;

  gcvt(us,ndig,tex);
  strcpy(TransfPVar.us,tex);
  gcvt(ls,ndig,tex);
  strcpy(TransfPVar.ls,tex);
  gcvt(ud,ndig,tex);
  strcpy(TransfPVar.ud,tex);
  gcvt(ld,ndig,tex);
  strcpy(TransfPVar.ld,tex);
  gcvt(um,ndig,tex);
  strcpy(TransfPVar.um,tex);
  gcvt(lm,ndig,tex);
  strcpy(TransfPVar.lm,tex);
  gcvt(usv,ndig,tex);
  strcpy(TransfPVar.usv,tex);
  gcvt(lsv,ndig,tex);
  strcpy(TransfPVar.lsv,tex);
  gcvt(udv,ndig,tex);
  strcpy(TransfPVar.udv,tex);
  gcvt(ldv,ndig,tex);
  strcpy(TransfPVar.ldv,tex);
  gcvt(umv,ndig,tex);
  strcpy(TransfPVar.umv,tex);
  gcvt(lmv,ndig,tex);
  strcpy(TransfPVar.lmv,tex);
  gcvt(ugv,ndig,tex);
  strcpy(TransfPVar.ugv,tex);
  gcvt(lgv,ndig,tex);
  strcpy(TransfPVar.lgv,tex);
  gcvt(vrp,ndig,tex);
  strcpy(TransfPVar.vrports,tex);
  gcvt(vwp,ndig,tex);
  strcpy(TransfPVar.vwports,tex);
  gcvt(memo,ndig2,tex1);
  strcpy(TransfPVar.memo,tex1);
  gcvt(banc,ndig2,tex1);
  strcpy(TransfPVar.banc,tex1);
  gcvt(llv,ndig,tex);
  strcpy(TransfPVar.llv,tex);


  if ( GetModule()->ExecDialog(
	       new TVariabDlg(this,"UNITS")) == IDOK )
  { memoria=((memo+3) >> 2);}

}


void TMDIFileWindow::Crear_Sim(RTMessage)
{
 HDC DC;

 if (BWCCMessageBox(HWindow, "Do you want to Create Simulation?", "Create Simulation", MB_OKCANCEL | MB_ICONHAND)== IDOK)
 {
 machPtr = Sim_Create(memoria, us, ls, um, lm, ud, ld, usv, lsv, umv, lmv,
		      udv, ldv, uld, llv, ugv, lgv, banc, vrp, vwp);
 if (machPtr != NULL) {
 menu = GetMenu(HWindow);
 EnableMenuItem(menu, CM_DESTROY, MF_ENABLED);
 EnableMenuItem(menu, CM_CARGA, MF_ENABLED);
 EnableMenuItem(menu, CM_CARGAT, MF_ENABLED);
 EnableMenuItem(menu, CM_ENSAMBLA, MF_ENABLED);
 EnableMenuItem(menu, CM_ESTADIST, MF_ENABLED);
 EnableMenuItem(menu, CM_TRACE, MF_ENABLED);
 EnableMenuItem(menu, CM_EXPF, MF_ENABLED);
 EnableMenuItem(menu, CM_EXOT, MF_ENABLED);
 EnableMenuItem(menu, CM_MODPF, MF_ENABLED);
 EnableMenuItem(menu, CM_MODOT, MF_ENABLED);
 EnableMenuItem(menu, CM_GO, MF_ENABLED);
 EnableMenuItem(menu, CM_GOCONT, MF_ENABLED);
 EnableMenuItem(menu, CM_STEP, MF_ENABLED);
 EnableMenuItem(menu, CM_STOPAT, MF_ENABLED);
 EnableMenuItem(menu, CM_STOPIN, MF_ENABLED);
 EnableMenuItem(menu, CM_STOPDE, MF_ENABLED);
 EnableMenuItem(menu, CM_PARAR, MF_ENABLED);
 EnableMenuItem(menu, CM_PASO, MF_ENABLED);
 EnableMenuItem(menu, CM_EXAVEC, MF_ENABLED);
 EnableMenuItem(menu, CM_MODVEC, MF_ENABLED);
 EnableMenuItem(menu, CM_BORRAR, MF_ENABLED);
 EnableMenuItem(menu, CM_INDICE, MF_ENABLED);
 EnableMenuItem(menu, CM_MODIFI, MF_ENABLED);
 EnableMenuItem(menu, CM_SALCAR, MF_ENABLED);
 EnableMenuItem(menu, CM_CREASIM, MF_GRAYED);
 // Marzo 98
 EnableMenuItem(menu, CM_EXFP, MF_ENABLED);
 EnableMenuItem(menu, CM_EXDFP, MF_ENABLED);
 EnableMenuItem(menu, CM_EXREG, MF_ENABLED);
 EnableMenuItem(menu, CM_EXSP, MF_ENABLED);

 maxbot = MBOT;

 DC = GetDC(HWindow);
 BlastBotones(HWindow, DC);
 ReleaseDC(HWindow, DC);

 // BWCCMessageBox(HWindow, "Simulador Creado Correctamente", "Informacin", MB_OK | MB_ICONINFORMATION);
 }
 else { BWCCMessageBox(HWindow, "Insufficient memory for Simulator","Memory Error", MB_OK | MB_ICONEXCLAMATION | MB_ICONSTOP);}
 }
}


void TMDIFileWindow::CMSalir(RTMessage)
{
 if (BWCCMessageBox(HWindow, "Do you want to Save the Simulation?", "Save Simulation", MB_OKCANCEL | MB_ICONHAND)== IDOK)
 {
   SendMessage(HWindow, WM_COMMAND, (WPARAM)IDM_EXIT, 0L);
 }
}



void TMDIFileWindow::Modi_Sim(RTMessage)
{ int i;

 if (BWCCMessageBox(HWindow,"Are you sure, You want to Modify Simulator Hardware?", " Hardware modification", MB_OKCANCEL | MB_ICONSTOP) == IDOK)
{
    for (i = (int)machPtr->num_add_units; i <us ; i++) machPtr->fp_units[(int)FP_ADD][i] = 0;
    for (i = (int)machPtr->num_div_units; i <ud ; i++) machPtr->fp_units[(int)FP_DIV][i] = 0;
    for (i = (int)machPtr->num_mul_units; i <um ; i++) machPtr->fp_units[(int)FP_MUL][i] = 0;

    for (i = (int)machPtr->num_addv_units; i <usv ; i++) machPtr->fp_units[(int)V_ADD][i] = 0;
    for (i = (int)machPtr->num_divv_units; i <udv ; i++) machPtr->fp_units[(int)V_DIV][i] = 0;
    for (i = (int)machPtr->num_mulv_units; i <umv ; i++) machPtr->fp_units[(int)V_MUL][i] = 0;
    for (i = (int)machPtr->num_logic_units; i <ugv ; i++) machPtr->fp_units[(int)V_LOGIC][i] = 0;

    machPtr->num_add_units = us;
    machPtr->num_mul_units = um;
    machPtr->num_div_units = ud;
    machPtr->fp_add_latency = ls;
    machPtr->fp_mul_latency = lm;
    machPtr->fp_div_latency = ld;
    machPtr->num_addv_units = usv;
    machPtr->num_mulv_units = umv;
    machPtr->num_divv_units = udv;
    machPtr->num_logic_units = ugv;
    machPtr->v_add_latency = lsv;
    machPtr->v_mul_latency = lmv;
    machPtr->v_div_latency = ldv;
    machPtr->v_logic_latency = lgv;
    machPtr->v_load_latency = llv;
    machPtr->bancos = banc;
    machPtr->read_ports = vrp;
    machPtr->read_ports = vwp;

    //BWCCMessageBox(HWindow, "Hardware del Simulador modificado correctamente", "Informacin", MB_OK | MB_ICONINFORMATION);
 }
}

void TMDIFileWindow::Ensamblar(RTMessage)
{
  strcpy(argumentos[0], "asm");
  machPtr->result[0] = '\0';
  if ( GetModule()->ExecDialog(
	       new TEnsDlg(this,"ASSEMBLER")) == IDOK ){
    Asm_AsmCmd(machPtr, numarg, argumentos);
    if (*machPtr->result != 0) {
     nombref = fopen("Ensamb.tmp","wt");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vensamb;
     presente = FALSE;
     Presentes();
     if (!presente) {GetApplication()->MakeWindow(new TNFileW(this, "Assembler", "Ensamb.tmp", Fuen, nfu));}
    }
    strcpy(argumentos[1], "add@f0,r1,r0");
    numarg = 2;
    Asm_AsmCmd(machPtr, numarg, argumentos);
    machPtr->result[0] = '\0';
 }
}


// Cargar objeto
void TMDIFileWindow::Cargar(RTMessage)
{

	RECT Coord;
	
	char *result;

rellenar((LPSTR)"Check program",
  (LPSTR)"Patterns (*.s)\0*.s\0All Files (*.*)\0*.*\0");

if (GetOpenFileName( &ofnTemp ) != TRUE)
	{       char Errstr[50]="Error in GetOpenFileName #";
		DWORD Errval;
		char buf[5];

		Errval=CommDlgExtendedError();
		if(Errval!=0)
		{
			sprintf(buf,"%ld",Errval);
			_fstrcat(Errstr,buf);
			BWCCMessageBox(HWindow,Errstr,"Warning",MB_OK|MB_ICONSTOP);
		}
	}
else
 {
  // Abril 98. Borramos simbolos automaticamente
  if (borrarauto && bProgramaCargado)
  {
  	Sym_Tabla(machPtr, memoria);  // Creo que este proc hace algo que no va bien, asi que evitemos llamarlo
  }
  bSalvarComo = FALSE;
  machPtr->result[0] = '\0';
  strcpy(argumentos[0], "load");
  strcpy(argumentos[1], szName);
  numarg = 2;
  Asm_LoadCmd(machPtr, numarg, argumentos);

  if (*machPtr->result != 0) {
    nombref = fopen("Carga.tmp","wt");
    fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
    fclose(nombref);
    ventana = vcargar;
    presente = FALSE;
    Presentes();
    if (!presente) {

    	GetClientRect( HWindow, &Coord);

	Ventana = (PTListWin)(GetApplication()->MakeWindow(new TListWin(this, "Check", 10, Coord.bottom-158, Coord.right-20, 108)));
	
	}
	else Ventana->Lista->ClearList();

    _fstrcpy(Ventana->Fichero, szName);
    nombref = fopen("Carga.tmp","rt");

    result = fgets(salidas, 190, nombref);
    if (salidas[_fstrlen(salidas)-1] == 0x0A)
	{salidas[_fstrlen(salidas)-1] = '\0';}

    while ( result != NULL)
    {
	Ventana->Lista->InsertString(salidas, -1);
	result = fgets(salidas, 190, nombref);
	if (salidas[_fstrlen(salidas)-1] == 0x0A)
		{salidas[_fstrlen(salidas)-1] = '\0';}
    }
    fclose(nombref);
    SendDlgItemMessage(Ventana->HWindow, 777, LB_SETHORIZONTALEXTENT, (WPARAM)1700, 0L);
    Ventana->Lista->SetSelIndex(0);
    machPtr->result[0] = '\0';
    }
    else {
    Limpia();
    BWCCMessageBox(HWindow,"File check correct","Informacion", MB_OK | MB_ICONINFORMATION);
    Actualizar();
    bProgramaCargado = TRUE;
    }

  }
}


//Cargar Fuente + Objeto
void TMDIFileWindow::CargarT(RTMessage)
{
	RECT Coord;
	char *result;

rellenar((LPSTR)"Check + Save Program",
  (LPSTR)"Patterns (*.s)\0*.s\0All Files (*.*)\0*.*\0");

if (GetOpenFileName( &ofnTemp ) != TRUE)
	{       char Errstr[50]="Error in GetOpenFileName #";
		DWORD Errval;
		char buf[5];

		Errval=CommDlgExtendedError();
		if(Errval!=0)
		{
			sprintf(buf,"%ld",Errval);
			_fstrcat(Errstr,buf);
			BWCCMessageBox(HWindow,Errstr,"Warning",MB_OK|MB_ICONSTOP);
		}
	}
else
 {
  wsprintf(ChildName,"DLXVSIM %d", ChildNum++);
  GetApplication()->MakeWindow(new TNFileW(this, ChildName, szName, Fuen, nfu));
  // Abril 98. Borramos simbolos automaticamente
  if (borrarauto && bProgramaCargado)
  {
	Sym_Tabla(machPtr, memoria);
  }
  bSalvarComo = FALSE;
  machPtr->result[0] = '\0';
  strcpy(argumentos[0], "load");
  strcpy(argumentos[1], szName);
  numarg = 2;
  Asm_LoadCmd(machPtr, numarg, argumentos);

  if (*machPtr->result != 0) {
    nombref = fopen("Carga.tmp","wt");
    fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
    fclose(nombref);
    ventana = vcargar;
    presente = FALSE;
    Presentes();
    if (!presente) {

    GetClientRect( HWindow, &Coord);

    Ventana = (PTListWin)(GetApplication()->MakeWindow(new TListWin(this, "Check", 10, Coord.bottom-158, Coord.right-20, 108)));

    }
    else Ventana->Lista->ClearList();

    _fstrcpy(Ventana->Fichero, szName);
    nombref = fopen("Carga.tmp","rt");

    result = fgets(salidas, 190, nombref);
    salidas[_fstrlen(salidas)-1] = '\0';

    while ( result != NULL)
    {
	Ventana->Lista->InsertString(salidas, -1);
	result = fgets(salidas, 190, nombref);
	salidas[_fstrlen(salidas)-1] = '\0';
    }
    fclose(nombref);
    SendDlgItemMessage(Ventana->HWindow, 777, LB_SETHORIZONTALEXTENT, (WPARAM)1700, 0L);
    Ventana->Lista->SetSelIndex(0);
    machPtr->result[0] = '\0';
    }
    else {
    Limpia();
    BWCCMessageBox(HWindow,"File check correct","Informacion", MB_OK | MB_ICONINFORMATION);
    Actualizar();
    bProgramaCargado = TRUE;
    }
 }
}


// Salvar+Cargar
void TMDIFileWindow::CMSalCar(RTMessage)
{

	RECT Coord;
	
	char *result;
	long	   resulto;
	PTWindowsObject	objeto;

/*        char mystr[80];
	LPSTR  Pmystr;
	char name[MAXPATH];
	char *ptr;
        char c='\\';
        int namelength; */

//Salvar
resulto = LOWORD(SendMessage(GetApplication()->MainWindow->GetClient()->HWindow, WM_MDIGETACTIVE, 0, 0));
if (resulto != 0)
 { objeto = GetModule()->GetParentObject((HWND)resulto);
   SendMessage(HWindow, WM_COMMAND, (WPARAM)IDM_SAVE, 0L);

/*   Pmystr = &mystr[0];
   GetWindowText(HWindow,Pmystr,GetWindowTextLength (HWindow));

   ptr = strchr (Pmystr,c);
   ptr--;
   ptr--;
   namelength = strlen(ptr);
   strncpy (ptr,name,namelength);
*/

if (bSalvarComo == 0) /* FALSE */
{
//Cargar
  // Mayo 98. Borramos simbolos automaticamente
/*  if (borrarauto & bProgramaCargado)
  {
      Sym_Tabla(machPtr, memoria);
  } */
  machPtr->result[0] = '\0';
  strcpy(argumentos[0], "load");
  strcpy(argumentos[1], ((PTNFileW)objeto)->szname);
  numarg = 2;
  Asm_LoadCmd(machPtr, numarg, argumentos);

  if (*machPtr->result != 0) {
    nombref = fopen("Carga.tmp","wt");
    fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
    fclose(nombref);
    ventana = vcargar;
    presente = FALSE;
    Presentes();
    if (!presente) {

    	GetClientRect( HWindow, &Coord);

	Ventana = (PTListWin)(GetApplication()->MakeWindow(new TListWin(this, "Check", 10, Coord.bottom-158, Coord.right-20, 108)));
	
	}
	else Ventana->Lista->ClearList();

    _fstrcpy(Ventana->Fichero, ((PTNFileW)objeto)->szname);
    nombref = fopen("Carga.tmp","rt");

    result = fgets(salidas, 190, nombref);
    if (salidas[_fstrlen(salidas)-1] == 0x0A)
	{salidas[_fstrlen(salidas)-1] = '\0';}

    while ( result != NULL)
    {
	Ventana->Lista->InsertString(salidas, -1);
	result = fgets(salidas, 190, nombref);
	if (salidas[_fstrlen(salidas)-1] == 0x0A)
		{salidas[_fstrlen(salidas)-1] = '\0';}
    }
    fclose(nombref);
    SendDlgItemMessage(Ventana->HWindow, 777, LB_SETHORIZONTALEXTENT, (WPARAM)1700, 0L);
    Ventana->Lista->SetSelIndex(0);
    machPtr->result[0] = '\0';
    }
    else {
    Limpia();
    BWCCMessageBox(HWindow,"File check correct","Informacion", MB_OK | MB_ICONINFORMATION);
    Actualizar();
    }
}
else {
    BWCCMessageBox(HWindow,"Load to Memory function is not correct after 'Save as'\nUtilice:\n 'Load Program->File'","Informacion", MB_OK | MB_ICONINFORMATION);
}
}
}


// Marzo 98
// Salvar Como
void TMDIFileWindow::CMSalvarComo(RTMessage)
{
   bSalvarComo = TRUE;
   SendMessage(HWindow, WM_COMMAND, (WPARAM)IDM_SAVEAS, 0L);
}





void TMDIFileWindow::Estad(RTMessage)
{ int i;

  strcpy(titulo, "Statistics(");
  strcpy(argumentos[0], "stats");
  machPtr->result[0] = '\0';
  if ( GetModule()->ExecDialog(
	       new TEstDlg(this,"STATISTICS")) == IDOK ){
  for (i=1;i<numarg;i++)
     {_fstrcat(titulo, argumentos[i]);
      _fstrcat(titulo, " ");}
    _fstrcat(titulo,")");
  Sim_DumpStats(machPtr, numarg, argumentos);
  if (*machPtr->result != 0) {
  ventana = vestadi;
  presente = FALSE;
  Presentes();
  if (!presente) {GetApplication()->MakeWindow(new TNFileW(this, titulo, "Estad.tmp", Fuen, nfu));}
  machPtr->result[0] = '\0';
  }
  else Actualizar();
  }
}

/* Los titulos de las ventanas deben ser ExaminarPF, ExaminarOT, ExaminarVE,
y contener los parametros que se han pasado al procedimiento que lee los
datos, ya que en el proc. DoActualiza hace uso de esta informacin */

// Examinar punto flotante
void TMDIFileWindow::Expf(RTMessage)
{ int result, i;

  strcpy(argumentos[0], "fget");
  machPtr->result[0] = '\0';
  result = IDRETRYM;
  while (result == IDRETRYM) {
  result = GetModule()->ExecDialog(
	       new TPFDlg(this,"EXFP"));
    if (result != IDCANCEL) {
    strcpy(titulo, "ExamineFP(");
    for (i=1;i<numarg;i++)
     {_fstrcat(titulo, argumentos[i]);
      _fstrcat(titulo, " ");}
    _fstrcat(titulo,")");
    Gp_FGetCmd(machPtr, numarg, argumentos);
    if (*machPtr->result != 0) {
     nombref = fopen("Exapf.tmp","wb");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vexam;
     presente = FALSE;
     Presentes();
     if (!presente) {
     GetApplication()->MakeWindow(new TNFileW(this, titulo, "Exapf.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
    }
  }
 }
}

// Marzo 98
// Examinar registros de coma flotante
void TMDIFileWindow::ExpFPRegs(RTMessage)
{ 
  strcpy(argumentos[0], "fget");
  strcpy(argumentos[1], "f0");
  strcpy(argumentos[2], "32f");
  strcpy(titulo, "ExamineFP(f0 32f )");
     Gp_FGetCmd(machPtr, 3, argumentos);
     if (*machPtr->result != 0) {
     nombref = fopen("Exapf.tmp","wb");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vexam;
     presente = FALSE;
     Presentes();
     if (!presente) {
     GetApplication()->MakeWindow(new TNFileW(this, titulo, "Exapf.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
 }
}


// Marzo 98
// Examinar registros de coma flotante de doble precisin
void TMDIFileWindow::ExpDFPRegs(RTMessage)
{
  strcpy(argumentos[0], "fget");
  strcpy(argumentos[1], "f0");
  strcpy(argumentos[2], "16d");
  strcpy(titulo, "ExamineFP(f0 16d )");
     Gp_FGetCmd(machPtr, 3, argumentos);
     if (*machPtr->result != 0) {
     nombref = fopen("Exapf.tmp","wb");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vexam;
     presente = FALSE;
     Presentes();
     if (!presente) {
     GetApplication()->MakeWindow(new TNFileW(this, titulo, "Exapf.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
 }
}


// Examinar otros
void TMDIFileWindow::Expot(RTMessage)
{ int result, i;

  strcpy(argumentos[0], "get");
  machPtr->result[0] = '\0';
  result = IDRETRYM;
  while (result == IDRETRYM) {
  result = GetModule()->ExecDialog(
	       new TExotDlg(this,"EXPOT"));
  if (result != IDCANCEL) {
    strcpy(titulo, "ExamineOT(");
    for (i=1;i<numarg;i++)
     {_fstrcat(titulo, argumentos[i]);
      _fstrcat(titulo, " ");}
    _fstrcat(titulo,")");
    Gp_GetCmd(machPtr, numarg, argumentos);
    if (*machPtr->result != 0) {
     nombref = fopen("Exaot.tmp","wb");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vexam;
     presente = FALSE;
     Presentes();
     if (!presente) {
     GetApplication()->MakeWindow(new TNFileW(this, titulo, "Exaot.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
    }
  }
 }
}

// Marzo 98
// Examinar Registros enteros
void TMDIFileWindow::ExpRegs(RTMessage)
{
  strcpy(argumentos[0], "get");
  strcpy(argumentos[1], "r0");
  strcpy(argumentos[2], "d32");
  strcpy(titulo, "ExamineOT(r0 d35 )");
     Gp_GetCmd(machPtr, 3, argumentos);
     if (*machPtr->result != 0) {
     nombref = fopen("Exaot.tmp","wb");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vexam;
     presente = FALSE;
     Presentes();
     if (!presente) {
     GetApplication()->MakeWindow(new TNFileW(this, titulo, "Exaot.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
 }
}


// Marzo 98
// Examinar registros especiales
void TMDIFileWindow::ExpSpecial(RTMessage)
{
  strcpy(argumentos[0], "get");
  strcpy(argumentos[1], "pc");
  strcpy(argumentos[2], "x5");
  strcpy(titulo, "ExamineOT(pc x5 )");
     Gp_GetCmd(machPtr, 3, argumentos);
     if (*machPtr->result != 0) {
     nombref = fopen("Exaot.tmp","wb");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vexam;
     presente = FALSE;
     Presentes();
     if (!presente) {
     GetApplication()->MakeWindow(new TNFileW(this, titulo, "Exaot.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
 }
}





void TMDIFileWindow::Modpf(RTMessage)
{
  strcpy(argumentos[0], "fput");
  machPtr->result[0] = '\0';
  if ( GetModule()->ExecDialog(
	       new TPutFDlg(this,"MODFP")) == IDOK ){
    Gp_FPutCmd(machPtr, numarg, argumentos);
    if (*machPtr->result != 0) {
     nombref = fopen("Modpf.tmp","wt");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vmodifF;
     presente = FALSE;
     Presentes();
     if (!presente) {
     GetApplication()->MakeWindow(new TNFileW(this, "ModifyFP", "Modpf.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
    }
    Actualizar();
 }
}

void TMDIFileWindow::Modot(RTMessage)
{
  strcpy(argumentos[0], "put");
  machPtr->result[0] = '\0';
  if ( GetModule()->ExecDialog(
	       new TModotDlg(this,"MODOT")) == IDOK ){
    Gp_PutCmd(machPtr, numarg, argumentos);
    if (*machPtr->result != 0) {
     nombref = fopen("Modot.tmp","wt");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vmodifT;
     presente = FALSE;
     Presentes();
     if (!presente) {
      GetApplication()->MakeWindow(new TNFileW(this, "ModifyOT", "Modot.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
    }
    Actualizar();
 }
}

// Ejecutar, desde
void TMDIFileWindow::GoDes(RTMessage)
{
  if (borraRegsauto) {
    regsReset(machPtr);
  }
// Parece interesante inicializar estadisticas:
  statsReset(machPtr);

  strcpy(argumentos[0], "go");
  machPtr->result[0] = '\0';
  if ( GetModule()->ExecDialog(
	       new TRunDlg(this,"GO")) == IDOK ){
    Sim_GoCmd(machPtr, numarg, argumentos);
    if (*machPtr->result != 0) {
     nombref = fopen("Ejec.tmp","wt");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vejecut;
     presente = FALSE;
     Presentes();
     if (!presente){
     GetApplication()->MakeWindow(new TNFileW(this, "Run", "Ejec.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
    }
    Actualizar();
 }
}

//Ejecutar, continuar
void TMDIFileWindow::GoCont(RTMessage)
{
  strcpy(argumentos[0], "go");
  machPtr->result[0] = '\0';
  numarg=1;
  Sim_GoCmd(machPtr, numarg, argumentos);
  if (*machPtr->result != 0) {
     nombref = fopen("Ejec.tmp","wt");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vejecut;
     presente = FALSE;
     Presentes();
     if (!presente){
     GetApplication()->MakeWindow(new TNFileW(this, "Run", "Ejec.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
    }
  Actualizar();
}

//Ejecutar Paso a paso, desde
void TMDIFileWindow::Step(RTMessage)
{
OFSTRUCT fil;
long int result;

  if (borraRegsauto) {
    regsReset(machPtr);
  }
// Parece interesante inicializar estadisticas:
  statsReset(machPtr);

  strcpy(argumentos[0], "step");
  machPtr->result[0] = '\0';
  if ( GetModule()->ExecDialog(
	       new TRunDlg(this,"STEP")) == IDOK ){
    result = Sim_StepCmd(machPtr, numarg, argumentos);
    if (*machPtr->result != 0) {
     ventana = vindice;
     presente = FALSE;
     Presentes();
     if ((!presente) || (result==TCL_ERROR)){
     OpenFile("Paso.tmp", &fil, OF_DELETE);
     nombref = fopen("Paso.tmp","at");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vpaso;
     presente = FALSE;
     Presentes();
     if (!presente){
     GetApplication()->MakeWindow(new TNFileW(this, "Step by Step", "Paso.tmp", Fuen, nfu));}}
     machPtr->result[0] = '\0';
    }
    Actualizar();
 }
}

//Ejecutar paso a paso, continuar
void TMDIFileWindow::Paso(RTMessage)
{

  strcpy(argumentos[0], "step");
  machPtr->result[0] = '\0';
  numarg=1;
  Sim_StepCmd(machPtr, numarg, argumentos);
  ventana = vindice;
  presente = FALSE;
  Presentes();
    if ((*machPtr->result != 0) && (!presente)) {
     nombref = fopen("Paso.tmp","at");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     longitud = _fstrlen((char far *)machPtr->result);
     ventana = vpaso;
     presente = FALSE;
     Presentes();
     if (!presente){
     GetApplication()->MakeWindow(new TNFileW(this, "Step by Step", "Paso.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
    }
    Actualizar();
}

void TMDIFileWindow::Stopat(RTMessage)
{

  strcpy(argumentos[0], "stop");
  strcpy(argumentos[1], "at");
  machPtr->result[0] = '\0';
  if ( GetModule()->ExecDialog(
	       new TStopatDlg(this,"STOPAT")) == IDOK ){
    Stop_StopCmd(machPtr, numarg, argumentos);
    if (*machPtr->result != 0) {
     nombref = fopen("Stopat.tmp","wt");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vstopat;
     presente = FALSE;
     Presentes();
     if (!presente) {
     GetApplication()->MakeWindow(new TNFileW(this, "Stop at", "Stopat.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
    }
    strcpy(argumentos[0], "stop");
    strcpy(argumentos[1], "info");
    numarg = 2;
    Stop_StopCmd(machPtr, numarg, argumentos);
    if (*machPtr->result != 0) {
	ventana = vstopin;
	presente = FALSE;
	Presentes();
	machPtr->result[0] ='\0';
    }
 }
}

void TMDIFileWindow::Stopin(RTMessage)
{
 machPtr->result[0] = '\0';
 strcpy(argumentos[0], "stop");
 strcpy(argumentos[1], "info");
 numarg = 2;
 Stop_StopCmd(machPtr, numarg, argumentos);
 if (*machPtr->result != 0) {
  ventana = vstopin;
  presente = FALSE;
  Presentes();
  if (!presente) {
  GetApplication()->MakeWindow(new TNFileW(this, "Stop info", "Stopin.tmp", Fuen, nfu));}
  machPtr->result[0] = '\0';
  }
}

void TMDIFileWindow::Stopde(RTMessage)
{

  strcpy(argumentos[0], "stop");
  strcpy(argumentos[1], "delete");
  machPtr->result[0] = '\0';
  if ( GetModule()->ExecDialog(
	       new TDelDlg(this,"STOPDE")) == IDOK ){
    Stop_StopCmd(machPtr, numarg, argumentos);
    if (*machPtr->result != 0) {
     nombref = fopen("Stopdel.tmp","wt");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vstopde;
     presente = FALSE;
     Presentes();
     if (!presente) {
     GetApplication()->MakeWindow(new TNFileW(this, "Stop delete", "Stopdel.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
    }
    strcpy(argumentos[0], "stop");
    strcpy(argumentos[1], "info");
    numarg = 2;
    Stop_StopCmd(machPtr, numarg, argumentos);
    if (*machPtr->result != 0) {
	ventana = vstopin;
	presente = FALSE;
	Presentes();
	machPtr->result[0] ='\0';
    }
 }
}

void TMDIFileWindow::Parar(RTMessage)
{
  machPtr->result[0] = '\0';
  strcpy(argumentos[0], "stop");
  numarg = 1;
  Stop_StopCmd(machPtr, numarg, argumentos);
}

void TMDIFileWindow::Destruir(RTMessage)
{
if (BWCCMessageBox(HWindow,"Are you sure, You want delete simbols associations in file?", "Simbols", MB_OKCANCEL | MB_ICONSTOP) == IDOK)
{
  rellenar((LPSTR)"Delete Simbol associations in file", (LPSTR)"Patterns (*.s)\0*.s\0All Files (*.*)\0*.*\0");

  if(GetOpenFileName( &ofnTemp ) != TRUE)
	{       char Errstr[50]="Error in GetOpenFileName #";
		DWORD Errval;
		char buf[5];

		Errval=CommDlgExtendedError();
		if(Errval!=0)
		{
			sprintf(buf,"%ld",Errval);
			_fstrcat(Errstr,buf);
			BWCCMessageBox(HWindow,Errstr,"Warning",MB_OK|MB_ICONSTOP);
		}
	}
 else { Sym_DeleteSymbols(machPtr, szName);
	BWCCMessageBox(HWindow, "Simbols Deleted", "Informacion",MB_OK | MB_ICONINFORMATION);
      }
}
}

void TMDIFileWindow::Trace(RTMessage)
{

  strcpy(argumentos[0], "trace");
  machPtr->result[0] = '\0';
  if ( GetModule()->ExecDialog(
	       new TTraDlg(this,"TRACE")) == IDOK ){
    Sim_TraceCmd(machPtr, numarg, argumentos);
    if (*machPtr->result != 0) {
     nombref = fopen("Traceon.tmp","wt");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vdinero;
     presente = FALSE;
     Presentes();
     if (!presente) {
     GetApplication()->MakeWindow(new TNFileW(this, "Dinero III", "Traceon.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
    }
 }
}

void TMDIFileWindow::Sobre(RTMessage)
{
	GetModule()->ExecDialog(new TDialog(this,(LPSTR)"ABOUT"));
}

void TMDIFileWindow::Fuentes(RTMessage)
{
	GetModule()->ExecDialog(new TFuentesDlg(this,(LPSTR)"FONTS"));
}

void TMDIFileWindow::Actu(RTMessage)
{
 BOOL antes;

 menu = GetMenu(HWindow);
 antes = CheckMenuItem(menu, CM_ACT, MF_UNCHECKED);
 actual = FALSE;
 if (antes == MF_UNCHECKED)
  {CheckMenuItem(menu, CM_ACT, MF_CHECKED);
   actual = TRUE;
  }
}

void TMDIFileWindow::Enca(RTMessage)
{
 BOOL antes;

 menu = GetMenu(HWindow);
 antes = CheckMenuItem(menu, CM_ENCA, MF_CHECKED);
 encadenado = TRUE;
 if (antes == MF_CHECKED)
  {CheckMenuItem(menu, CM_ENCA, MF_UNCHECKED);
   encadenado = FALSE;
  }
}


//Abril 98
void TMDIFileWindow::SetBorrarAuto(RTMessage)
{
 BOOL antes;

 menu = GetMenu(HWindow);
 antes = CheckMenuItem(menu, CM_BORRARAUTO, MF_CHECKED);
 borrarauto = TRUE;
 if (antes == MF_CHECKED)
  {CheckMenuItem(menu, CM_BORRARAUTO, MF_UNCHECKED);
   borrarauto = FALSE;
  }
}


//Mayo 2003
void TMDIFileWindow::SetBorraRegsAuto(RTMessage)
{
 BOOL antes;

 menu = GetMenu(HWindow);
 antes = CheckMenuItem(menu, CM_BORRAREGSAUTO, MF_CHECKED);
 borraRegsauto = TRUE;
 if (antes == MF_CHECKED)
  {CheckMenuItem(menu, CM_BORRAREGSAUTO, MF_UNCHECKED);
   borraRegsauto = FALSE;
  }
}

// Marzo 98
void TMDIFileWindow::ExaVect(RTMessage)
{
  strcpy(argumentos[0], "vget");
  strcpy(argumentos[1], "v0");
  strcpy(argumentos[2], "8");
  strcpy(titulo, "ExamineVE(v0 8 )");
     Gp_Vget(machPtr, argumentos);
     if (*machPtr->result != 0) {
     nombref = fopen("Exav.tmp","wb");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vexam;
     presente = FALSE;
     Presentes();
     if (!presente) {
     GetApplication()->MakeWindow(new TNFileW(this, titulo, "Exav.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
 }
}
/*
{
int result, i;

  strcpy(argumentos[0], "vget");
  machPtr->result[0] = '\0';
  result = IDRETRYM;
  while (result == IDRETRYM) {
  result = GetModule()->ExecDialog(
	       new TExavDlg(this,"VECTOR"));
   if (result != IDCANCEL) {
    strcpy(titulo, "ExaminarVE(");
    for (i=1;i<numarg;i++)
     {_fstrcat(titulo, argumentos[i]);
      _fstrcat(titulo, " ");}
    _fstrcat(titulo,")");
    Gp_Vget(machPtr, argumentos);
    if (*machPtr->result != 0) {
     nombref = fopen("Exav.tmp","wb");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vexam;
     presente = FALSE;
     Presentes();
     if (!presente) {
     GetApplication()->MakeWindow(new TNFileW(this, titulo, "Exav.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
    }
   }
 }
}
*/

void TMDIFileWindow::ModVect(RTMessage)
{ int i, j;
  char tex[vec];
  if ( GetModule()->ExecDialog(
	       new TElegDlg(this,"SELECT")) == IDOK )
  {
  for (i = 0; i < MVL; i++)
  { double *source;

    j = i*2;
    source = (double *)&(machPtr->vecregs[registro][j]);
    gcvt(*source, vec/2, tex);
    strcpy(PVect.vector[i], tex);
  }
  if ( GetModule()->ExecDialog(
	       new TModVDlg(this,"MODVEC")) == IDOK )
  {
  Actualizar();
  }
  }
}

void TMDIFileWindow::Borrar(RTMessage)
{                                                                                                    
if (BWCCMessageBox(HWindow,"Are you sure, You want delete all simbols associations in Simulator?", "Simbols", MB_OKCANCEL | MB_ICONSTOP) == IDOK)
{
 Sym_Tabla(machPtr, memoria);
 BWCCMessageBox(HWindow, "All Simbols are deleted", "Informacion",MB_OK | MB_ICONINFORMATION);
 }
}



//Abril 98
void TMDIFileWindow::ExpPCFast(RTMessage)
{
int i;

  strcpy(argumentos[0], "pcget");
  strcpy(argumentos[1], "-5");
  strcpy(argumentos[2], "10");
  strcpy(titulo, "ExaminePC(");
  numarg = 3;
    for (i=1;i<numarg;i++)
     {_fstrcat(titulo, argumentos[i]);
      _fstrcat(titulo, " ");}
    _fstrcat(titulo,")");
    Gp_PCindex(machPtr, argumentos);
    if (*machPtr->result != 0) {
     nombref = fopen("Index.tmp","wb");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vexam;
     presente = FALSE;
     Presentes();
     if (!presente) {
     GetApplication()->MakeWindow(new TNFileW(this, titulo, "Index.tmp", Fuen, nfu));}
// Esto no ha llegado a funcionar: PostMessage(HWindow, WM_COMMAND, (WPARAM) IDM_TAMA, 0L);

     machPtr->result[0] = '\0';
    }
}


void TMDIFileWindow::Indice(RTMessage)
{
int result, i;

  strcpy(argumentos[0], "pcget");
  machPtr->result[0] = '\0';
  result = IDRETRYM;
  while (result == IDRETRYM) {
  result = GetModule()->ExecDialog(
	       new TIndexDlg(this,"PC"));
   if (result != IDCANCEL) {
    strcpy(titulo, "ExaminePC(");
    for (i=1;i<numarg;i++)
     {_fstrcat(titulo, argumentos[i]);
      _fstrcat(titulo, " ");}
    _fstrcat(titulo,")");
    Gp_PCindex(machPtr, argumentos);
    if (*machPtr->result != 0) {
     nombref = fopen("Index.tmp","wb");
     fwrite(machPtr->result,sizeof(char),_fstrlen((char far *)machPtr->result),nombref);
     fclose(nombref);
     ventana = vexam;
     presente = FALSE;
     Presentes();
     if (!presente) {
     GetApplication()->MakeWindow(new TNFileW(this, titulo, "Index.tmp", Fuen, nfu));}
     machPtr->result[0] = '\0';
    }
   }
 }
}

void TMDIFileWindow::Sistema(RTMessage)
{
	GetModule()->ExecDialog(new TVentanaInfoSis(this, (LPSTR)"INFOSIS" ));
}




void TMDIFileApp::InitMainWindow()
{
  MainWindow = new TMDIFileWindow("DLXVSIM", "Commands");
  ((PTMDIFileWindow)MainWindow)->ChildMenuPos = 5;
  Fuen = (HFONT) GetStockObject(ANSI_FIXED_FONT); nfu = 0;
  BWCCGetVersion();
}

BOOL TMDIFileApp::ProcessAppMsg(LPMSG Message)
{
   DWORD   dwHelpContextId;
   long	   resulto;
   PTWindowsObject	objeto;
   int		x,y,i,j,k;
   char		cad1[30];

   switch (Message->message) {

       case WM_KEYDOWN:
	   if (Message->wParam == VK_F1) {

	       if (GetKeyState(VK_SHIFT)<0) {
		   bAyuda = TRUE;
		   SetCursor(hCursorAyuda);
		   DefWindowProc(Message->hwnd, Message->message, Message->wParam, Message->lParam);
		   return TRUE;
	       }

	       else if (GetKeyState(VK_CONTROL)<0) {
		   resulto = LOWORD(SendMessage(MainWindow->GetClient()->HWindow, WM_MDIGETACTIVE, 0, 0));
		   if (resulto != 0) { objeto = GetParentObject((HWND)resulto);
				       ((PTEditWindow)objeto)->Editor->GetSelection(x, y);

                                       y=x-29;if (y<0) {y=0;}
				       ((PTEditWindow)objeto)->Editor->GetSubText(cad1, y, x);
				       
				       y = _fstrlen(cad1)-1;
				       k = y+1;
				       while (isalnum(cad1[y]) && (y>=0)) {y--;}
                                       j=0;
				       for (i=++y;i<k;i++,j++) {salidas[j] = cad1[i];}
				       salidas[j] ='\0';

				       ((PTEditWindow)objeto)->Editor->GetSubText(cad1, x, x+29);
				       y = 0;
				       while (isalnum(cad1[y]) && (y<28)) {y++;}
				       if (y<29) cad1[y] = '\0';
				       _fstrcat(salidas, cad1);

				       WinHelp(Message->hwnd, NombreAyuda,HELP_PARTIALKEY,(DWORD)(LPSTR)salidas);
				       }
		   }
		   else {
			   WinHelp(Message->hwnd,NombreAyuda,HELP_INDEX,0L);
	       }
	   }

	   else if (Message->wParam == VK_ESCAPE && bAyuda) {

	       bAyuda = FALSE;
	       SetCursor((HCURSOR)GetClassWord(Message->hwnd,GCW_HCURSOR));
	   }
	   else {
	   return (ProcessAccels(Message) || ProcessDlgMsg(Message) ||  ProcessMDIAccels(Message));
	   }
       break;

       case WM_NCLBUTTONDOWN:

	   if (bAyuda) {
	       dwHelpContextId =
		   (Message->wParam == HTCAPTION)     ? (DWORD) HELPID_TITLE_BAR     :
		   (Message->wParam == HTREDUCE)      ? (DWORD) HELPID_MINIMIZE_ICON :
		   ((Message->wParam == HTZOOM) && IsZoomed(Message->hwnd)) ? (DWORD) HELPID_GROW:
		   (Message->wParam == HTZOOM)        ? (DWORD) HELPID_MAXIMIZE_ICON :
		   (Message->wParam == HTHSCROLL)     ? (DWORD) HELPID_SCROLL :
		   (Message->wParam == HTVSCROLL)     ? (DWORD) HELPID_SCROLL :
		   (Message->wParam == HTLEFT)	      ? (DWORD) HELPID_SIZING_BORDER :
		   (Message->wParam == HTTOP)	      ? (DWORD) HELPID_SIZING_BORDER :
		   (Message->wParam == HTTOPLEFT)	      ? (DWORD) HELPID_SIZING_BORDER :
		   (Message->wParam == HTTOPRIGHT)	      ? (DWORD) HELPID_SIZING_BORDER :
		   (Message->wParam == HTBOTTOM)	      ? (DWORD) HELPID_SIZING_BORDER :
		   (Message->wParam == HTBOTTOMLEFT)	      ? (DWORD) HELPID_SIZING_BORDER :
		   (Message->wParam == HTBOTTOMRIGHT)	      ? (DWORD) HELPID_SIZING_BORDER :
					       (DWORD) 0L;

	       if (dwHelpContextId) {
			bAyuda = FALSE;
			WinHelp(Message->hwnd,NombreAyuda,HELP_CONTEXT,dwHelpContextId);
			break;
			}
	       }


       default:
       return (ProcessAccels(Message) || ProcessDlgMsg(Message) ||  ProcessMDIAccels(Message));

   }

return TRUE;
}

void TMDIFileWindow::WMCommand(RTMessage Msg)
{
DWORD   dwHelpContextId;

	
  if (bAyuda) {
      dwHelpContextId =
      (Msg.WParam == IDM_NEW)    ? (DWORD) HELPID_FILE_NEW     :
      (Msg.WParam == IDM_OPEN)   ? (DWORD) HELPID_FILE_OPEN    :
      (Msg.WParam == IDM_SAVE)   ? (DWORD) HELPID_FILE_SAVE    :
      (Msg.WParam == IDM_SAVEAS) ? (DWORD) HELPID_FILE_SAVE_AS :
      (Msg.WParam == CM_FUENTES) ? (DWORD) HELPID_FILE_FUENTES :
      (Msg.WParam == CM_FILEPRINT) ? (DWORD) HELPID_FILE_IMPR  :
      (Msg.WParam == CM_FILEPRINTERSETUP) ? (DWORD) HELPID_FILE_CIMPR:
      (Msg.WParam == IDM_EXIT)   ? (DWORD) HELPID_FILE_EXIT    :
      (Msg.WParam == IDM_UNDO)   ? (DWORD) HELPID_EDIT_UNDO    :
      (Msg.WParam == IDM_CUT)    ? (DWORD) HELPID_EDIT_CUT     :
      (Msg.WParam == IDM_CLEAR)  ? (DWORD) HELPID_EDIT_CLEAR   :
      (Msg.WParam == IDM_COPY)   ? (DWORD) HELPID_EDIT_COPY    :
      (Msg.WParam == IDM_PASTE)  ? (DWORD) HELPID_EDIT_PASTE   :
      (Msg.WParam == IDM_BUSC)   ? (DWORD) HELPID_BUS_BUSC     :
      (Msg.WParam == IDM_REEM)   ? (DWORD) HELPID_BUS_REEM     :
      (Msg.WParam == IDM_SIGU)   ? (DWORD) HELPID_BUS_SIGU     :
      (Msg.WParam == IDM_IRA)    ? (DWORD) HELPID_BUS_IRA      :
      (Msg.WParam == IDM_MOSA)   ? (DWORD) HELPID_VEN_MOSA     :     
      (Msg.WParam == IDM_CASC)   ? (DWORD) HELPID_VEN_CASC     :
      (Msg.WParam == IDM_REDI)   ? (DWORD) HELPID_VEN_REDI     :
      (Msg.WParam == IDM_CERR)   ? (DWORD) HELPID_VEN_CERR     :
      (Msg.WParam == IDM_BORR)   ? (DWORD) HELPID_EDIT_CLEARALL:
      (Msg.WParam == IDM_HELP_INDEX)      ? (DWORD) HELPID_AYU_INDI   :
      (Msg.WParam == IDM_HELP_KEYBOARD)   ? (DWORD) HELPID_AYU_TECL   :
      (Msg.WParam == IDM_HELP_HELP)       ? (DWORD) HELPID_AYU_USAN   :

      (Msg.WParam == CM_SAVESTATE)      ? (DWORD) HELPID_VEN_SALV       :
      (Msg.WParam == CM_RESTORESTATE)   ? (DWORD) HELPID_VEN_REST       :
      (Msg.WParam == CM_VARIAB)         ? (DWORD) HELPID_SIM_CONF       :
      (Msg.WParam == CM_CREASIM)        ? (DWORD) HELPID_SIM_CREA       :
      (Msg.WParam == CM_MODIFI)         ? (DWORD) HELPID_SIM_MODI       :
      (Msg.WParam == CM_CARGA)          ? (DWORD) HELPID_SIM_OBJE       :
      (Msg.WParam == CM_ENSAMBLA)       ? (DWORD) HELPID_SIM_ENSA       :
      (Msg.WParam == CM_ESTADIST)       ? (DWORD) HELPID_SIM_ESTA       :
      (Msg.WParam == CM_EXPF)           ? (DWORD) HELPID_SIM_EPUN       :
      (Msg.WParam == CM_EXOT)           ? (DWORD) HELPID_SIM_EOTR       :
      (Msg.WParam == CM_MODPF)          ? (DWORD) HELPID_SIM_MPUN       :
      (Msg.WParam == CM_MODOT)          ? (DWORD) HELPID_SIM_MOTR       :
      (Msg.WParam == CM_GO)             ? (DWORD) HELPID_EJE_EJEC       :
      (Msg.WParam == CM_GOCONT)         ? (DWORD) HELPID_EJE_EJEO       :
      (Msg.WParam == CM_STEP)           ? (DWORD) HELPID_EJE_PASD       :
      (Msg.WParam == CM_STOPAT)         ? (DWORD) HELPID_EJE_STEN       :
      (Msg.WParam == CM_STOPIN)         ? (DWORD) HELPID_EJE_STIN       :
      (Msg.WParam == CM_STOPDE)         ? (DWORD) HELPID_EJE_STBO       :
      (Msg.WParam == CM_PARAR)          ? (DWORD) HELPID_EJE_STPA       :
      (Msg.WParam == CM_DESTROY)        ? (DWORD) HELPID_SIM_FICH       :
      (Msg.WParam == CM_TRACE)          ? (DWORD) HELPID_SIM_TRAZ       :
      (Msg.WParam == CM_SOBRE)          ? (DWORD) HELPID_AYU_ACER       :
      (Msg.WParam == CM_SISTEMA)        ? (DWORD) HELPID_AYU_SIST       :
      (Msg.WParam == CM_PASO)           ? (DWORD) HELPID_EJE_PASC       :
      (Msg.WParam == CM_ACT)            ? (DWORD) HELPID_EJE_ACTU       :
      (Msg.WParam == CM_EXAVEC)         ? (DWORD) HELPID_SIM_EVEC       :
      (Msg.WParam == CM_MODVEC)         ? (DWORD) HELPID_SIM_MVEC       :
      (Msg.WParam == CM_BORRAR)         ? (DWORD) HELPID_SIM_TODO       :
      (Msg.WParam == CM_INDICE)         ? (DWORD) HELPID_SIM_EPCI       :
      (Msg.WParam == CM_ENCA)           ? (DWORD) HELPID_EJE_ENCA       :
      (Msg.WParam == CM_CARGAT)         ? (DWORD) HELPID_SIM_FUEN       :
      (Msg.WParam == IDM_VEN1)		? (DWORD) HELPID_VEN_LIST	:
      (Msg.WParam == IDM_VEN2)		? (DWORD) HELPID_VEN_LIST	:
      (Msg.WParam == IDM_VEN3)		? (DWORD) HELPID_VEN_LIST	:
      (Msg.WParam == IDM_VEN4)		? (DWORD) HELPID_VEN_LIST	:
      (Msg.WParam == IDM_VEN5)		? (DWORD) HELPID_VEN_LIST	:
      (Msg.WParam == IDM_VEN6)		? (DWORD) HELPID_VEN_LIST	:
      (Msg.WParam == IDM_VEN7)		? (DWORD) HELPID_VEN_LIST	:
      (Msg.WParam == IDM_VEN8)		? (DWORD) HELPID_VEN_LIST	:
      (Msg.WParam == IDM_VEN9)		? (DWORD) HELPID_VEN_LIST	:
      (Msg.WParam == IDM_VEN0)		? (DWORD) HELPID_VEN_LIST	:
					    (DWORD) 0L;

      if (!dwHelpContextId)
	   {
	   BWCCMessageBox(Msg.Receiver, "Help is unreachable from this location",
	   "Help", MB_OK);
	   DefWndProc(Msg);
	   bAyuda = FALSE;
	   goto fin;
	   }
      bAyuda = FALSE;
      WinHelp(Msg.Receiver,NombreAyuda,HELP_CONTEXT,dwHelpContextId);
      }

      else { TWindowsObject::WMCommand(Msg);}
 fin:;
}

void TMDIFileWindow::WMSysCommand(RTMessage Msg)
{
DWORD   dwHelpContextId;

  if ((bAyuda) && ((Msg.WParam & 0xFFF0)!= SC_KEYMENU) && ((Msg.WParam & 0xFFF0) != SC_MOUSEMENU)) {
      dwHelpContextId =
      ((int)Msg.WParam == IDM_REST)    ? (DWORD) HELPID_SYS_REST     :
      ((int)Msg.WParam == IDM_MOVE)   ? (DWORD) HELPID_SYS_MOVE    :
      ((int)Msg.WParam == IDM_TAMA)   ? (DWORD) HELPID_SYS_TAMA    :
      ((int)Msg.WParam == IDM_MINI) ? (DWORD) HELPID_SYS_MINI :
      ((int)Msg.WParam == IDM_MAXI)   ? (DWORD) HELPID_SYS_MAXI    :
      ((int)Msg.WParam == IDM_SALI)   ? (DWORD) HELPID_SYS_SALI    :
      ((int)Msg.WParam == IDM_CAMB)    ? (DWORD) HELPID_SYS_CAMB     :
					    (DWORD) 0L;

      if (!dwHelpContextId)
	   {
	   BWCCMessageBox(Msg.Receiver, "Help in unreachable from this location",
	   "Help", MB_OK);
	   DefWndProc(Msg);
	   bAyuda = FALSE;
	   goto fin;
	   }
      bAyuda = FALSE;
      WinHelp(Msg.Receiver,NombreAyuda,HELP_CONTEXT,dwHelpContextId);
      }

      else { TWindowsObject::WMCommand(Msg);}
 fin:;
}

void TMDIFileWindow::WMIdle(RTMessage Msg)
{
if ( (Msg.WParam == MSGF_MENU) && ( GetKeyState(VK_F1) & 0x8000) ) {
	       bAyuda = TRUE;
	       PostMessage(Msg.Receiver, WM_KEYDOWN, VK_RETURN, 0L);
	       }
else DefWndProc(Msg);
}

void TMDIFileWindow::WMCursor(RTMessage Msg)
{
	if (Pintado && ((HWND)Msg.WParam != HWindow))
	    {
	 	HDC DC, memDC;
	 	HANDLE oldBmp;

	 
	 	DC = GetDC(HWindow);
	 	memDC = CreateCompatibleDC(DC);
	 	oldBmp = SelectObject(memDC, Botones[BPintado].bmpa);
		BitBlt(DC, BPintado*TAMBOTH, 0, TAMBOTH, TAMBOTV, memDC, 0, 0, SRCCOPY);
	 	SelectObject(memDC, oldBmp);
	 	DeleteDC(memDC);
		ReleaseDC(HWindow, DC);
		Pintado = FALSE;
		CurrentID = 1;
		drawStatusLine(HWindow);
	    }
	else if (bAyuda) {
	       SetCursor(hCursorAyuda);
	   }
	else {
	DefWndProc(Msg);}
}

void TMDIFileWindow::WMPaint(RTMessage)
{
	DoPaint(HWindow);
	CurrentID = 1;
	drawStatusLine(HWindow);
}

void TMDIFileWindow::WMSize(RTMessage)
{
	DoSize(HWindow);
}

void TMDIFileWindow::WMMenuSel(RTMessage Msg)
{
	menuSelect(Msg.Receiver, Msg.WParam, Msg.LParam);
}

void TMDIFileWindow::WMStatus(RTMessage Msg)
{
	drawStatusLine(Msg.Receiver);
}

void TMDIFileWindow::WMFicheros(RTMessage)
{
	TNFileW	*Pruebas;
	int	error;


	presente = FALSE;
	Errores();
	if (!presente)
        	{
		wsprintf(ChildName,"DLXVSIM %d", ChildNum++);
		Pruebas = (PTNFileW)(GetApplication()->MakeWindow(new TNFileW(this, ChildName, Ventana->Fichero, Fuen, nfu)));
		error = Pruebas->Editor->Search(0, Ventana->Result, TRUE);
		if (error == -1)
			{Pruebas->Ira(Ventana->Linea);}
		}
}

void TMDIFileApp::InitInstance()
{
  TApplication::InitInstance();
  if ( Status == 0 )
  {
    HAccTable = LoadAccelerators(hInstance, "FileCommands");
    if ( HAccTable == 0 )
      Status = EM_INVALIDWINDOW;
  }
}

void HacerNombreCamino(char *szFileName)
{
   char *  pcFileName;
   int     nFileNameLen;

   nFileNameLen = GetModuleFileName(hInst,szFileName,EXE_NAME_MAX_SIZE);
   pcFileName = szFileName + nFileNameLen;

   while (pcFileName > szFileName) {
       if (*pcFileName == '\\' || *pcFileName == ':') {
	   *(++pcFileName) = '\0';
	   break;
       }
   nFileNameLen--;
   pcFileName--;
   }

   if ((nFileNameLen+13) < EXE_NAME_MAX_SIZE) {
       lstrcat(szFileName, "dlxvsim.hlp");
   }

   else {
       lstrcat(szFileName, "?");
   }

   return;
}

BOOL TFileOut::IsNextPage()
{
 return NuevaPag;
}

void TFileOut::PrintPage(HDC DC, WORD, POINT, LPRECT, WORD)
{
  HFONT hfont, hfontOld;
  BOOL flag;
  int Vert, indi, indice, i, i1, j, lineas, BFue, MapModePrevious, iPtSize[4] = {14, 18, 12, 12}, iPtPor[4] = {2, 2, 2, 2};
  PSTR pszFace[4] = {"Courier New", "Courier New", "Terminal", "Fixedsys"};
  PTFEdit Informe;
  char *punt;

  Informe = Archiv->Editor;
  BFue = Informe->nfuente;

  SaveDC(DC);

  MapModePrevious = SetMapMode(DC, MM_TEXT);

  Vert = GetDeviceCaps(DC, VERTRES);

  hfont = CreateFont(-iPtSize[BFue]*2, 0, 0, 0, 0,
	  0, 0, 0, 0, 0, 0, 0, 0, pszFace[BFue]);     
  hfontOld = (HFONT)SelectObject(DC, hfont);

  lineas = Informe->GetNumLines();
  if (Inicio) {Primera = 0; Inicio = FALSE;}

  for (i=0;Primera<lineas;i++, Primera++)
  {

  indi = (i + 1) * iPtSize[BFue] * iPtPor[BFue];

  if ((indi + 6*iPtSize[BFue] * iPtPor[BFue]) > Vert) {NuevaPag = TRUE; return;}

  flag = Informe->GetLine(salidas, 198, Primera);

  punt = _fstrrchr(salidas, '\t');

  if (punt)
	{
	indice = 0;
	for (i1 = 0;((i1<198) && (salidas[i1] != '\0') && (indice<198));i1++)
		{
		if (salidas[i1] == '\t') { temporal[indice] = ' ';
					   indice++;
					   for (j = indice; ((indice % 8) != 0);j++)
					   {temporal[indice] = ' ';
			 		    indice++;
					   }
					  }
		else
		{temporal[indice] = salidas[i1];indice++;
		}
		}
	temporal[indice] = '\0';
	_fstrcpy(salidas, temporal);
	}


  if (flag)
     {
     TextOut(DC, 10, indi, salidas, lstrlen(salidas));
     }
                                                     
  }

  SetMapMode(DC, MapModePrevious);
  SelectObject(DC, hfontOld);
  DeleteObject(hfont);

  RestoreDC(DC, -1);
  NuevaPag = FALSE;

}


void TMDIFileWindow::CMFilePrinterSetup(RTMessage)
{
  if ( Printer )
        Printer->Setup(this);
}

void TMDIFileWindow::CMFilePrint(RTMessage)
{
  PTFileOut Printout = 0;
  PTNFileW  Archivo;

  Archivo = (PTNFileW)((PTMDIFileWindow(GetApplicationObject()->MainWindow))->ActiveChild);

  if (( Printer ) && (Archivo != NULL))
  {
    Printout = new TFileOut(Archivo->Title , Archivo);
    if ( Printout )
    {
      Printout->SetBanding( FALSE );
      Printer->Print(this, Printout);
      delete Printout;
    }
  }
}


int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
		   LPSTR lpCmd, int nCmdShow)
{ 
    TMDIFileApp MDIFileApp("DlxvSim", hInstance, hPrevInstance,
		lpCmd, nCmdShow);
    hInst = hInstance;
    signal(SIGINT, (fptr)Interrupt);
    HacerNombreCamino(NombreAyuda);
    MDIFileApp.Run();
    if (easy != NULL) {DestroyWindow(easy);}
    if (bmpStatusLine)
        DeleteObject(bmpStatusLine);
    DeleteObject(bmpStatusBar);
    return MDIFileApp.Status;
}
