// Dlxvsim.h --
// Fichero que contiene diversas declaraciones necesarias
// para el entorno desarrollado para el simulador del DLXV.

/****************************************************************
 * PROYECTO FINAL DE CARRERA:		        		*
 *	Simulador Vectorial para PC bajo entorno Windows	*
 * 		                                		*
 *      Autor: Roberto Calpe Lorenzo				*
 *                                                              *
 ****************************************************************/

/* Estas constantes deben tener el mismo valor que las que se
hayan definido en dlxvsim.res, con el resource workshop.
Asi podemos asociar a cada item del menu una accion */
#define CM_SAVESTATE     200
#define CM_RESTORESTATE  201
#define CM_VARIAB	 202
#define CM_CREASIM	203
#define CM_CARGA	204
#define CM_ENSAMBLA	205
#define	CM_ESTADIST     206
#define	CM_EXPF		207
#define	CM_EXOT		208
#define	CM_MODPF	209
#define	CM_MODOT	210
#define	CM_GO		211
#define	CM_STEP		212
#define	CM_STOPAT	213
#define	CM_STOPIN	214
#define	CM_STOPDE	215
#define CM_DESTROY	216
#define CM_TRACE	217
#define CM_SOBRE	218
#define CM_PASO		219
#define CM_ACT		220
#define CM_EXAVEC	221
#define	CM_MODVEC	222
#define CM_BORRAR	223
#define CM_INDICE	224
#define CM_ENCA		225
#define CM_CARGAT	226
#define CM_PARAR	227
#define CM_MODIFI	228
#define CM_SISTEMA	229
#define CM_GOCONT	230
#define CM_FUENTES	231
#define CM_FILEPRINTERSETUP	232
#define CM_FILEPRINT		233
#define CM_SALCAR		234
#define CM_SALIR		235
/* Marzo 98 */
#define CM_SALCOMO		236
#define	CM_EXFP			237
#define	CM_EXDFP		238
#define	CM_EXREG		239
#define	CM_EXSP                 240
#define	CM_EXPCFAST             241
#define CM_BORRARAUTO           242
#define CM_BORRAREGSAUTO        243


#define Nombre		1

#define WM_STATUS	WM_USER+1
#define WM_FUENTES	WM_USER+2


#define ID_SumNum	101
#define ID_SumLat	102
#define ID_DivNum	103
#define ID_DivLat	104
#define ID_MultNum	105
#define ID_MultLat	106
#define ID_SumVNum	107
#define ID_SumVLat	108
#define ID_DivVNum	109
#define ID_DivVLat	110
#define ID_MultVNum	111
#define ID_MultVLat	112
#define ID_Memoria	113
#define ID_LogVNum	114
#define	ID_LogVLat	115
#define ID_Bancos	116
#define ID_PLec         131
#define ID_PEsc         132
#define IDRETRYM	34
#define ID_DOS  	2000 
#define ID_DOS1		2001
#define ID_DOS2		2002
#define	ID_DOS3		2003
#define ID_DOS4		2004
#define ID_DOS5		2005
#define ID_DOS6		2006
#define ID_DOS7		2007
#define ID_DOS8		2008
#define ID_DOS9		2009
#define	ID_DOS10	2010
#define ID_DOS11	2011
#define ID_DOS12	2012
#define ID_DOS64	2064
#define ID_GROUPBOX	101

/* Estas constantes tienen que ver con la ayuda sensible al
contexto */
#define HELPID_EDIT_CLEAR     1795
#define HELPID_EDIT_COPY      1027
#define HELPID_EDIT_CUT       771
#define HELPID_EDIT_PASTE     1283
#define HELPID_EDIT_UNDO      259
#define HELPID_EDIT_CLEARALL	8210
#define HELPID_FILE_EXIT      3586
#define HELPID_FILE_NEW       258
#define HELPID_FILE_OPEN      514
#define HELPID_FILE_SAVE      1026
#define HELPID_FILE_SAVE_AS   1282
#define HELPID_FILE_FUENTES	8409
#define HELPID_FILE_IMPR	8410
#define HELPID_FILE_CIMPR	8411

#define HELPID_SIM_CONF		8229
#define HELPID_SIM_CREA		8232
#define HELPID_SIM_MODI		8394
#define HELPID_SIM_TODO		8249
#define HELPID_SIM_FICH		8256
#define HELPID_SIM_OBJE		8265
#define HELPID_SIM_FUEN		8266
#define HELPID_SIM_ENSA		8235
#define HELPID_SIM_ESTA		8236
#define HELPID_SIM_TRAZ		8237
#define HELPID_SIM_EPUN		8253
#define HELPID_SIM_EVEC		8257
#define HELPID_SIM_EPCI		8258
#define HELPID_SIM_EOTR		8259
#define HELPID_SIM_MPUN		8254
#define HELPID_SIM_MVEC		8260
#define HELPID_SIM_MOTR		8261
#define HELPID_EJE_EJEC		8231
#define HELPID_EJE_EJEO		8397
#define HELPID_EJE_PASD		8240
#define HELPID_EJE_PASC		8241
#define HELPID_EJE_STEN		8255
#define HELPID_EJE_STIN		8262
#define HELPID_EJE_STBO		8263
#define HELPID_EJE_STPA		8393
#define HELPID_EJE_ACTU		8243
#define HELPID_EJE_ENCA		8244
#define HELPID_BUS_BUSC		8227
#define HELPID_BUS_SIGU		8216
#define HELPID_BUS_REEM		8217
#define HELPID_BUS_IRA		8395
#define HELPID_VEN_MOSA		1284
#define HELPID_VEN_CASC		8219
#define HELPID_VEN_REDI		8220
#define HELPID_VEN_CERR		8221
#define HELPID_VEN_SALV		8222
#define HELPID_VEN_REST		8223
#define HELPID_VEN_LIST		8408
#define HELPID_AYU_INDI		2345
#define HELPID_AYU_TECL		8224
#define HELPID_AYU_USAN		8225
#define HELPID_AYU_ACER		8226
#define HELPID_AYU_SIST		8396

#define HELPID_EDIT_WINDOW    300
#define HELPID_GROW	      8399
#define HELPID_MAXIMIZE_ICON  8403
#define HELPID_MINIMIZE_ICON  8402
#define HELPID_SYSTEM_MENU    8398
#define HELPID_TITLE_BAR      8285
#define HELPID_SCROLL	      8406
#define HELPID_SIZING_BORDER  8407
#define HELPID_SYS_REST	      8399
#define HELPID_SYS_MOVE	      8400
#define HELPID_SYS_TAMA       8401
#define HELPID_SYS_MINI       8402
#define HELPID_SYS_MAXI       8403
#define HELPID_SYS_SALI       8404
#define HELPID_SYS_CAMB       8405

#define IDM_NEW      24331
#define IDM_OPEN     24332
#define IDM_SAVE     24333
#define IDM_SAVEAS   24334
#define IDM_EXIT     24340
#define	IDM_BUSC	24326
#define IDM_REEM	24327
#define	IDM_SIGU	24328
#define IDM_IRA		24341
#define	IDM_MOSA	24336
#define	IDM_CASC	24337
#define	IDM_REDI	24335
#define IDM_CERR	24338
#define IDM_BORR	24324
#define CM_LINEA        24341
#define IDM_VEN1	3841
#define IDM_VEN2	3842
#define IDM_VEN3	3843
#define IDM_VEN4	3844
#define IDM_VEN5	3845
#define IDM_VEN6	3846
#define IDM_VEN7	3847
#define IDM_VEN8	3848
#define IDM_VEN9	3849
#define IDM_VEN0	3850
#define IDM_REST	-3808
#define IDM_MOVE	-4080
#define IDM_CAMB	-3792
#define IDM_TAMA	-4096
#define IDM_SALI	-4000
#define IDM_MINI	-4064
#define IDM_MAXI	-4048
#define IDM_PRINC	-3947


#define     IDM_UNDO     24325
#define     IDM_CUT      24320
#define     IDM_COPY     24321
#define     IDM_PASTE    24322
#define     IDM_CLEAR    24323

#define     IDM_ABOUT          218
#define     IDM_HELP_INDEX     301
#define     IDM_HELP_KEYBOARD  302
#define     IDM_HELP_HELP      300

#define EXE_NAME_MAX_SIZE  128



#define lng		  3
#define lng2		  8
#define vec		 20
#define TAMBOTH		26
#define TAMBOTV		22

#define vensamb	0
#define vestadi	1
#define vcargar	2
#define vmodifF 3
#define vmodifT 4
#define vejecut 5
#define vstopat 6
#define vstopin 7
#define vstopde 8
#define vdinero 9
#define vindice 10
#define vpaso	11
#define vexam	12

#define ID_ENHANCED	41
#define ID_STANDARD	42
#define ID_REAL		43
#define ID_CPU8086	44
#define ID_CPU80186	45
#define ID_CPU80286	46
#define ID_CPU80386	47
#define ID_CPU80486	48
#define ID_YES		49
#define ID_NO		50
#define ID_UNKNOWN	51

#define ID_OPERATIONMODE 	202
#define ID_CPUTYPE		203
#define ID_COPROCESSOR		204
#define ID_GLOBAL	 	205
#define ID_VERSIONDOS		206

#define TextStart 		  200
#define bmp_StatusBar		  101
#define bmp_StatusLine            100
#define bmp_Herramienta		  103
#define bmp_botones		  1
#define StatusLineHeight          22
#define EditFirst                 IDM_UNDO
#define SimulFirst		  CM_VARIAB
#define EjecuFirst		  CM_GO
#define FileFirst                 IDM_NEW
#define HelpFirst                 IDM_HELP_INDEX
#define BuscaFirst                IDM_BUSC
#define BorraFirst		  CM_BORRAR
#define CargaFirst		  CM_CARGA
#define ExaFirst                  CM_EXPF
#define ModiFirst                 CM_MODPF
#define StopFirst                 CM_STOPAT
#define WindowFirst               IDM_MOSA
#define SysFirst		  IDM_REST

/* Estas constantes representan una tira de caracteres definida
en dlxvsim.res */
#define  sth_Open                        2
#define  sth_Save                        3
#define  sth_SaveAs                      4
#define  sth_Print                       5
#define  sth_Options_Open                6
#define	sth_File		8
#define	sth_Edit		15
#define	sth_View		19
#define	sth_EjecuFirst		25
#define	sth_Window		33
#define	sth_Help		40
#define sth_Borra		61
#define sth_Carga               62
#define sth_Exam                63
#define sth_Modi		64
#define sth_Stop                65
#define  sth_Mouse                      13
#define  sth_Preferences                14
#define	sth_FileNew		1
#define	sth_FileOpen		2
#define	sth_FileSave		3
#define	sth_FileSaveAs		4
#define	sth_FilePrint		5
#define	sth_FileSaveLoad	6
#define	sth_FileExit		100
#define sth_Nombre		101
#define	sth_EditUndo		9
#define	sth_EditCut		10
#define	sth_EditCopy		11
#define	sth_EditPaste		12
#define	sth_EditClear		13
#define	sth_EditDelete		14
#define	sth_Buscar		16
#define sth_Busq		60
#define	sth_SalvarE		17
#define	sth_Restaura		18
#define sth_Encade		19
#define	sth_Config		20
#define	sth_SimulFirst		21
#define	sth_Crear		22
#define	sth_Modif		23
#define	sth_Borr		24
#define	sth_Borrf		26
#define	sth_Cargao		27
#define	sth_WindowTile		28
#define	sth_WindowCascade		29
#define	sth_WindowArrange		30
#define	sth_Reempl		31
#define	sth_WindowCloseAll	32
#define	sth_HelpIndex		34
#define sth_Teclado		35
#define sth_Siguiente		36
#define sth_Ira			37
#define	sth_HelpUsing		38
#define	sth_HelpAbout		39

#define	sth_Cargat		52
#define	sth_Ensamb		53
#define	sth_Estadist		54
#define	sth_Trace		55
#define	sth_Expf		56
#define	sth_Exv			57
#define	sth_Ind			58
#define	sth_Exo			59
#define	sth_Modpf		66

#define	sth_Modv		67
#define	sth_Modot		68
#define	sth_Go			69
#define	sth_Gocont		70
#define	sth_Step		71
#define	sth_Paso		72
#define	sth_Stopat		73
#define	sth_Stopin		74
#define	sth_Stopde		75
#define	sth_Parar		76
#define	sth_Act			77
#define	sth_Sistema		79

#define sth_Ventana		80
#define sth_VentMen		81
#define sth_VentRes		82
#define sth_Syst		83
#define sth_Mover		84
#define sth_Cambi		85
#define sth_Tama		86
#define sth_Cerr		100
#define sth_Mini		87
#define sth_Maxi		88
#define sth_Fuen		102
#define sth_Fs			103
#define sth_Fp                  104

//Marzo 98
#define sth_Regs                 105
#define sth_FPRegs               106
#define sth_DFPRegs              107
#define sth_SPRegs               108
#define sth_BorrarAuto           109
#define sth_BorraRegsAuto           110



HFONT Fuen;

long int us=NUM_ADD_UNITS,ls=FP_ADD_LATENCY,ud=NUM_DIV_UNITS,ld=FP_DIV_LATENCY,
	 um=NUM_MUL_UNITS,lm=FP_MUL_LATENCY,usv=NUM_VADD_UNITS,lsv=V_ADD_PEN,
	 udv=NUM_VDIV_UNITS,ldv=V_DIV_PEN,umv=NUM_VMUL_UNITS,lmv=V_MUL_PEN,
	 memo=MEMSIZE, memoria=16384, uld = NUM_LD_UNITS, llv = V_LD_PEN,
	 ugv = NUM_LG_UNITS, lgv = V_LG_PEN, banc = NUM_BANCOS;
int vrp = RPORTS; /* Numero de puertos de lectura */
int vwp = WPORTS; /* Numero de puertos de escritura */

struct PTransfVar
{
	char us[lng], ls[lng], ud[lng], ld[lng], um[lng],
	lm[lng], usv[lng], lsv[lng], udv[lng], ldv[lng],
	umv[lng], lmv[lng], ugv[lng], lgv[lng], vrports[lng],
	vwports[lng], memo[lng2], banc[lng+2], llv[lng];
};

struct PEns
{
	char primero[largus+1];
	char segundo[largus+1];
};

struct P1Ens
{
	char primero[largus+1];
};

struct PTVec
{
	char vector[MVL][vec];
};

PEns	PEnsVar;
P1Ens	P1EnsVar;
PTransfVar TransfPVar;
PTVec	PVect;


char argumentos[argus][largus];
int numarg,
    presente,
    ventana, auxbut = 0, nfu;