/*
 * List_Init.c --
 *
 *	Codigo fuente del procedimiento de libreria List_Init.
 *
 * Copyright 1988 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 */

/****************************************************************
 * PROYECTO FINAL DE CARRERA:		        		*
 *	Simulador Vectorial para PC bajo entorno Windows	*
 * 		                                		*
 *      Autor: Roberto Calpe Lorenzo				*
 *                                                              *
 ****************************************************************/

#include <stdlib.h>
#include <bwcc.h>
#include "list.h"

/*
 * ----------------------------------------------------------------------------
 *
 * List_Init --
 *
 *	Inicializa un puntero de cabecera que apunte una lista vacia. La
 *	estructura List_Links debe ser aun alojada en memoria.
 *
 * Resultados:
 *	Ninguno.
 *
 * Efectos Laterales:
 *	El puntero de cabecera es modificado para que apunte a si mismo.
 *
 * ----------------------------------------------------------------------------
 */
void
List_Init(headerPtr)
    register List_Links *headerPtr;  /* Puntero a la estructura List_Links
				      * que va a ser la cabecera. */
{
    if (headerPtr == (List_Links *) NIL || !headerPtr) {
    /* *** panic *** */
	BWCCMessageBox(GetFocus(),"List_Init: invalid header pointer.\nTerminating.", "Fatal Error", MB_OK | MB_SYSTEMMODAL | MB_ICONSTOP);
	exit(-1);
    }
    headerPtr->nextPtr = headerPtr;
    headerPtr->prevPtr = headerPtr;
}
