/*
 * List_Insert.c --
 *
 *	Codigo fuente para el procedimiento de libreria List_Insert.
 *
 * Copyright 1988 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 */

/****************************************************************
 * PROYECTO FINAL DE CARRERA:		        		*
 *	Simulador Vectorial para PC bajo entorno Windows	*
 * 		                                		*
 *      Autor: Roberto Calpe Lorenzo				*
 *                                                              *
 ****************************************************************/

#include <stdlib.h>
#include <bwcc.h>
#include "list.h"

/*
 * ----------------------------------------------------------------------------
 *
 * List_Insert --
 *
 *	Inserta el elemento de la lista apuntado por itemPtr en una Lista
 *	despues de destPtr. Ademas realiza un test para retornar un error
 *	si el elemento de la lista esta siendo insertado a continuacion de
 *	el mismo.
 *
 * Resultados:
 *	Ninguno.
 *
 * Efectos Laterales:
 *	La lista que contiene destPtr es modificada para que contenga itemPtr.
 *
 * ----------------------------------------------------------------------------
 */
void
List_Insert(itemPtr, destPtr)
    register	List_Links *itemPtr;	/* estructura a insertar */
    register	List_Links *destPtr;	/* estructura tras la cual vamos a
					 * insertarlo */
{
    extern char far salidas[199];
    if (itemPtr == (List_Links *) NIL || destPtr == (List_Links *) NIL
	    || !itemPtr || !destPtr) {
	/* ***panic*** */
	wsprintf(salidas,"List_Insert: itemPtr (%x) or destPtr (%x) is NIL.\nTerminate.",
		  (unsigned long int) itemPtr, (unsigned long int) destPtr);
	BWCCMessageBox(GetFocus(), salidas, "Fatal Error", MB_OK | MB_ICONSTOP | MB_SYSTEMMODAL);
	exit(-1);
	return;
    }
    if (itemPtr == destPtr) {
	/* *** panic *** */
	BWCCMessageBox(GetFocus(),"List_Insert: trying to insert something after itself.\nTerminate.","Fatal Error",
	MB_OK | MB_ICONSTOP | MB_SYSTEMMODAL);
	exit(-1);
	return;
    }
    itemPtr->nextPtr = destPtr->nextPtr;
    itemPtr->prevPtr = destPtr;
    destPtr->nextPtr->prevPtr = itemPtr;
    destPtr->nextPtr = itemPtr;
}
