/*
 * List_Remove.c --
 *
 *	Codigo fuente para el procedimiento de libreria List_Remove.
 *
 * Copyright 1988 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 */

/****************************************************************
 * PROYECTO FINAL DE CARRERA:		        		*
 *	Simulador Vectorial para PC bajo entorno Windows	*
 * 		                                		*
 *      Autor: Roberto Calpe Lorenzo				*
 *                                                              *
 ****************************************************************/

#include <stdlib.h>
#include <bwcc.h>
#include "list.h"

/*
 * ----------------------------------------------------------------------------
 *
 * List_Remove --
 *
 *	Borra un elemento de la lista de la lista que lo contenia.
 *
 * Resultados:
 *	Ninguno.
 *
 * Efectos Laterales:
 *	La estructura dada es borrada de la lista que lo contiene.
 *
 * ----------------------------------------------------------------------------
 */
void
List_Remove(itemPtr)
    register	List_Links *itemPtr;	/* Elemento de la lista a borrar */
{
    if (itemPtr == (List_Links *) NIL || itemPtr == itemPtr->nextPtr
	    || !itemPtr) {
	/* ***panic*** */
	BWCCMessageBox(GetFocus(), "List_Remove: invalid item to remove.\nTerminating.", "Fatal Error", MB_OK | MB_ICONSTOP | MB_SYSTEMMODAL);
	exit(-1);
    }
    if (itemPtr->prevPtr->nextPtr != itemPtr ||
	itemPtr->nextPtr->prevPtr != itemPtr) {
	/* ***panic*** */
	BWCCMessageBox(GetFocus(),"List_Remove: item's pointers are invalid.\nTerminating.", "Fatal Error",
	MB_OK | MB_ICONSTOP | MB_SYSTEMMODAL);
	exit(-1);
    }
    itemPtr->prevPtr->nextPtr = itemPtr->nextPtr;
    itemPtr->nextPtr->prevPtr = itemPtr->prevPtr;
}
