/*
 * Hash.c --
 *
 *	Codigo fuente para Hash, un procedimiento usado por la
 *	libraria de tablas Hash.
 *
 * Copyright 1988 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 */

/****************************************************************
 * PROYECTO FINAL DE CARRERA:		        		*
 *	Simulador Vectorial para PC bajo entorno Windows	*
 * 		                                		*
 *      Autor: Roberto Calpe Lorenzo				*
 *                                                              *
 ****************************************************************/


#include "hash.h"
#include "list.h"

/*
 *---------------------------------------------------------
 *
 * Hash --
 *	Este es un procedimiento local que calcula la direccion
 *	de un bucket de la tabla hash basandose en el valor de
 *	un string.
 *
 * Resultados:
 *	El valor devuelto es un entero (32 bits)entre 0
 *	y tamao - 1.
 *
 * Efectos laterales:
 *	Ninguno.
 *
 *---------------------------------------------------------
 */

long int
Hash(tablePtr, key)
    register Hash_Table *tablePtr;
    register char 	*key;
{
    register long int 	i = 0;
    register long int 	j;
    register long int 	*intPtr;

    switch (tablePtr->keyType) {
	case HASH_STRING_KEYS:
	    while (*key != 0) {
		i = (i * 10) + (*key++ - '0');
	    }
	    break;
	case HASH_ONE_WORD_KEYS:
	    i = (long int) key;
	    break;
	case 2:
	    i = ((long int *) key)[0] + ((long int *) key)[1];
	    break;
	default:
	    j = tablePtr->keyType;
	    intPtr = (long int *) key;
	    do {
		i += *intPtr++;
		j--;
	    } while (j > 0);
	    break;
    }


    return(((i*1103515245L + 12345) >> tablePtr->downShift) & tablePtr->mask);
}
