/*
 * Hash_DeleteEntry.c --
 *
 *	Codigo fuente para el procedimiento de libreria Hash_DeleteEntry.
 *
 * Copyright 1988 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 */

/****************************************************************
 * PROYECTO FINAL DE CARRERA:		        		*
 *	Simulador Vectorial para PC bajo entorno Windows	*
 * 		                                		*
 *      Autor: Roberto Calpe Lorenzo				*
 *                                                              *
 ****************************************************************/

#include <alloc.h>
#include "hash.h"
#include "list.h"


/*
 * Procedimientos utiles definidos en otros ficheros:
 */

extern Hash_Entry *     HashChainSearch();
extern long int         Hash();
/*
 *---------------------------------------------------------
 *
 * Hash_DeleteEntry --
 *
 * 	Borra de la tabla hash la entrada proporcionada y libera la memoria
 *	asociada a la misma.
 *
 * Resultados:
 *	Ninguno.
 *
 * Efectos Laterales:
 *	La cadena hash donde se encuentra la entrada es modificada y es
 *	liberada memoria.
 *
 *---------------------------------------------------------
 */

void
Hash_DeleteEntry(tablePtr, hashEntryPtr)
    Hash_Table			*tablePtr;
    register	Hash_Entry	*hashEntryPtr;
{
    if (hashEntryPtr != (Hash_Entry *) NULL) {
	List_Remove((List_Links *) hashEntryPtr);
	farfree((Address) hashEntryPtr);
	tablePtr->numEntries--;
    }
}
