/*
 * Hash_EnumFirst.c --
 *
 *	Codigo fuente para el procedimiento de libreria Hash_EnumFirst.
 *
 * Copyright 1988 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 */

/****************************************************************
 * PROYECTO FINAL DE CARRERA:		        		*
 *	Simulador Vectorial para PC bajo entorno Windows	*
 * 		                                		*
 *      Autor: Roberto Calpe Lorenzo				*
 *                                                              *
 ****************************************************************/

#include "hash.h"
#include "list.h"

/*
 *---------------------------------------------------------
 *
 * Hash_EnumFirst --
 *	Este procedimiento prepara las cosas para una busqueda completa
 *	de todas las entradas presentes en la tabla hash.
 *
 * Resultados:
 *	El valor de retorno es la direccion de la primera entrada de la
 *	tabla hash , o NULL si la tabla esta vacia.
 *
 * Efectos Laterales:
 *	La informacion presente en hashSearchPtr es inicializada de manera
 *	que sucesivas llamadas a Hash_Next retornaran las sucesivas entradas
 *	(HashEntry's) de la tabla.
 *
 *---------------------------------------------------------
 */

Hash_Entry *
Hash_EnumFirst(tablePtr, hashSearchPtr)
    Hash_Table *tablePtr;			/* Tabla en la que buscar. */
    register Hash_Search *hashSearchPtr;	/* Area en la cual mantener el
						 * estado de la busqueda.
						 */
{
    hashSearchPtr->tablePtr = tablePtr;
    hashSearchPtr->nextIndex = 0;
    hashSearchPtr->hashEntryPtr = (Hash_Entry *) NULL;
    return Hash_EnumNext(hashSearchPtr);
}
