/*
 * sym.h --
 *
 *	Declaraciones de procedimientos exportados por el modulo que
 *	se encarga de manejar la tabla de simbolos del simulador.
 *
 * Copyright 1989 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 */

/****************************************************************
 * PROYECTO FINAL DE CARRERA:		        		*
 *	Simulador Vectorial para PC bajo entorno Windows	*
 * 		                                		*
 *      Autor: Roberto Calpe Lorenzo				*
 *                                                              *
 ****************************************************************/

#ifndef _SYM
#define _SYM

/*
 * Valores devueltos por Sym_GetSym:
 */

#define SYM_FOUND	0L
#define SYM_REGISTER	1L
#define SYM_AMBIGUOUS	2L
#define SYM_NOT_FOUND	3L
#define SYM_REG_NOT_OK	4L
#define SYM_FREG_FOUND	5L
#define SYM_VREG_FOUND	6L

/*
 * Flags a pasar a Sym_GetSym:
 */

#define SYM_REGS_OK		0x1L
#define SYM_PSEUDO_OK		0x2L
#define SYM_FREGS_OK		0x4L
#define SYM_VREGS_OK		0x8L

/*
 * Flags a pasar a Sym_AddSymbol:
 */

/* Hay que dejar el valor 1 disponible de manera que el SYM_REGISTER definido
 * arriba pueda ser usado. */
#define SYM_NO_ADDR	0x2L
#define SYM_GLOBAL	0x4L

extern long int	Sym_AddSymbol();
extern void	Sym_DeleteSymbols();
extern long int	Sym_GetSym();
extern long int	Sym_EvalExpr();
extern char *	Sym_GetString();
extern void	Sym_Tabla();

#endif /* _SYM */

